/**
* @package Sprites
*/

/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CBaseSpr.h						*
 *													*
 *	Header for CBaseSpr.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CBASESPR
#define CBASESPR

#include "Types2.h"
#include "Graphic.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define M_POS_Xc	m_posX+4
#define M_POS_Yc	m_posY+4


#define DIR_BOTTOM	0
#define DIR_LEFT	1
#define DIR_TOP		2
#define DIR_RIGHT	3

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

/**
* Base class for all sprites
*/
class CBaseSpr
{

public:
	/**
	* Standard constructor
	* @param objID define the sprite ID
	* @param iniX initial X position of sprite
	* @param iniY initial Y position of sprite
	*/
	CBaseSpr(uchar objID, short initX, short initY);

public:
	/**
	* position X of sprite
	*/
	short m_posX;
	/**
	* position Y of sprite
	*/
	short m_posY;
	/**
	* TRUE if sprite is enable
	*/
	BOOL m_enable;
	/**
	* sprite(=object) ID to know what the sprite is
	*/
	uchar m_objectID;

public:
	/**
	* @return m_enable
	*/
	virtual inline BOOL IsEnable();
	/**
	* Draw the sprite (must be implemented in sub-class)
	*/
	virtual void Draw();
	/**
	* set m_enable to TRUE
	*/
	virtual inline void SetEnable();
	/**
	* set m_enable to FALSE
	*/
	virtual inline void SetDisable();
	/**
	* set m_pos to (x,y)
	*/
	virtual inline void SetPos(short x, short y);
};

#endif