/**
* @package Enemies
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CE_Bloc.h						*
 *													*
 *	Header for CE_Bloc.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CE_BLOC
#define CE_BLOC

#include "Types2.h"
#include "CEnemy.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define BLOC_DAMAGE				-1
#define BLOC_LIFE				0	//can't be killed with weapon

#define BLOC_SPR_ID_ALL			28
#define BLOC_ANI_LEN			4

#define BLOC_MARGE_BOTTOM		0
#define BLOC_MARGE_RIGHT		0
#define BLOC_MARGE_LEFT			-1
#define BLOC_MARGE_TOP			-1

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Class Bloc Enemy which create an unkillable enemy
*/
class  CE_Bloc : public CEnemy
{

public:
	/**
	* Standard constructor
	* @see CEnemy#CEnemy()
	*/
	CE_Bloc(short initX, short initY);

public:


public:
	/**
	* No move for this enemy
	* @see CEnemy#AutoMove()
	*/
	BOOL AutoMove();
	/**
	* Can't be kill with weapon
	* @see CEnemy#SetDamaged()
	*/
	void SetDamaged();
	/**
	* Can't be kill with weapon
	* @see CEnemy#SetKilled()
	*/
	void SetKilled();
	/**
	* Can't be kill with weapon
	* @see CEnemy#IncLife()
	*/
	char IncLife(char inc);
	/**
	* Can't be moved by something
	*/
	BOOL MoveTo(uchar tDir);
};

#endif