/****************************************************
 *	Original name : CE_Boun.cpp						*
 *													*
 *	Class for using bounce enemy.					*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CE_Boun.h"
#include "Data.h"
#include <stdlib.h>
#include "Map.h"

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CE_Boun::CE_Boun(short initX, short initY)
	:CEnemy(ENEMY_BOUNC, initX, initY
	,BOUNCE_MARGE_BOTTOM
	,BOUNCE_MARGE_LEFT
	,BOUNCE_MARGE_TOP
	,BOUNCE_MARGE_RIGHT
	,BOUNCE_DAMAGE
	,BOUNCE_LIFE
	,BOUNCE_SPR_ID_ALL
	,BOUNCE_SPR_ID_ALL
	,BOUNCE_SPR_ID_ALL
	,BOUNCE_SPR_ID_ALL
	,BOUNCE_ANI_LEN)
{
	m_stepRnd=12;
	m_stepOffset=8;
	m_stepSpeed=3;

}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CE_Boun::AutoMove()
{
	switch(m_stateMove)
	{
	case STATE_CHOOSE_DEST:
		m_nbrStep=m_stepOffset+rand()%m_stepRnd;
		m_goDir=rand()%4;
		m_stateMove=STATE_GO_DEST;
		break;
	case STATE_GO_DEST:
		if (globalTimer%m_stepSpeed==0)
		{
			if(m_nbrStep==0) m_stateMove=STATE_CHOOSE_DEST;
			m_nbrStep--;

			MoveTo(m_goDir);
			if(!MoveTo((m_goDir+1)%4)) return FALSE;
		}
		break;
	}

	return TRUE;
}