/**
* @package Enemies
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CE_Boun.h						*
 *													*
 *	Header for CE_Boun.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CE_BOUN
#define CE_BOUN

#include "Types2.h"
#include "CEnemy.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define BOUNCE_DAMAGE			-2
#define BOUNCE_LIFE				1


#define BOUNCE_SPR_ID_ALL		24	
#define BOUNCE_ANI_LEN			4	

#define	BOUNCE_MARGE_BOTTOM		1
#define	BOUNCE_MARGE_LEFT		1
#define	BOUNCE_MARGE_TOP		2
#define	BOUNCE_MARGE_RIGHT		1

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Class Bounce Enemy which is an enemy who jump
*/
class CE_Boun : public CEnemy
{

public:
	/**
	* Standard constructor
	* @see CEnemy#CEnemy()
	*/
	CE_Boun(short initX, short initY);

public:
	/**
	* Diagonal move for this enemy
	* @see CEnemy#AutoMove()
	*/
	BOOL AutoMove();

};

#endif