/****************************************************
 *	Original name : CE_Folow.cpp					*
 *													*
 *	Class for using follower enemy.					*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CE_Folow.h"
#include "Data.h"
#include <stdlib.h>
#include "Map.h"

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CE_Folow::CE_Folow(short initX, short initY)
	:CEnemy(ENEMY_FOLOW, initX, initY
	,FOLLOWER_MARGE_BOTTOM
	,FOLLOWER_MARGE_LEFT
	,FOLLOWER_MARGE_TOP
	,FOLLOWER_MARGE_RIGHT
	,FOLLOWER_DAMAGE
	,FOLLOWER_LIFE
	,FOLLOWER_SPR_ID_ALL
	,FOLLOWER_SPR_ID_ALL
	,FOLLOWER_SPR_ID_ALL
	,FOLLOWER_SPR_ID_ALL
	,FOLLOWER_ANI_LEN)
{
	m_stepSpeed=2;
	m_directionH=0;
	m_directionV=0;

	m_internState=STATE_FOLLOW;
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CE_Folow::AutoMove()
{
	if (globalTimer%m_stepSpeed!=0) return TRUE;

	switch(m_internState)
	{
	case STATE_FOLLOW:
		if(hero.m_posY>m_posY+FOLLOWER_PRECISION) m_directionV=DIR_BOTTOM;
		if(hero.m_posY<m_posY-FOLLOWER_PRECISION) m_directionV=DIR_TOP;
		if(hero.m_posX>m_posX+FOLLOWER_PRECISION) m_directionH=DIR_RIGHT;
		if(hero.m_posX<m_posX-FOLLOWER_PRECISION) m_directionH=DIR_LEFT;

		if(!MoveTo(m_directionH)) m_internState=STATE_BREAK_H;
		if(!MoveTo(m_directionV)) m_internState=STATE_BREAK_V;

		break;
	case STATE_BREAK_H:
		if(!MoveTo(m_directionV)) m_directionV=NotDirection();
		if(MoveTo(m_directionH)) m_internState=STATE_FOLLOW;
		break;
	case STATE_BREAK_V:
		if(!MoveTo(m_directionH)) m_directionH=NotDirection();
		if(MoveTo(m_directionV)) m_internState=STATE_FOLLOW;
		break;
	}

	//to avoid break on wall
	if (globalTimer%FOLLOWER_TEMPO==0) m_internState=STATE_FOLLOW;

	return TRUE;
}
