/**
* @package Enemies
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CE_Folow.h						*
 *													*
 *	Header for CE_Folow.cpp							*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CE_FOLOW
#define CE_FOLOW

#include "Types2.h"
#include "CEnemy.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define FOLLOWER_DAMAGE				-2
#define FOLLOWER_LIFE				3


#define FOLLOWER_SPR_ID_ALL			32	
#define FOLLOWER_ANI_LEN			8


#define	FOLLOWER_MARGE_BOTTOM		1
#define	FOLLOWER_MARGE_LEFT			1
#define	FOLLOWER_MARGE_TOP			1
#define	FOLLOWER_MARGE_RIGHT		1

//define for AI
#define	STATE_FOLLOW				0
#define	STATE_BREAK_H				1
#define	STATE_BREAK_V				2
#define	FOLLOWER_PRECISION			1
#define FOLLOWER_TEMPO				96

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Class Follower Enemy which create an "Intelligent" enemy who follow Kliz
*/
class CE_Folow : public CEnemy
{

public:
	/**
	* Standard constructor
	* @see CEnemy#CEnemy()
	*/
	CE_Folow(short initX, short initY);

public:
	/**
	* Horizontal direction. Can be DIR_LEFT or DIR_RIGHT
	*/
	char m_directionH;
	/**
	* Vertical direction. Can be DIR_TOP or DIR_BOTTOM
	*/
	char m_directionV;
	/**
	* Internal state for little AI
	*/
	char m_internState;

public:
	/**
	* First enemy with AI for moving
	* @see CEnemy#AutoMove()
	*/
	BOOL AutoMove();

};

#endif