/****************************************************
 *	Original name : CE_Shad1.cpp					*
 *													*
 *	Class for using Shadow Boss 1.					*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CE_Shad1.h"
#include "Data.h"
#include <stdlib.h>
#include "Map.h"
#include "DrwSprSW.h"

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CE_Shad1::CE_Shad1(short initX, short initY)
	:CEnemy(ENEMY_SHADOW1, initX, initY
	,SHAD1_MARGE_BOTTOM
	,SHAD1_MARGE_LEFT
	,SHAD1_MARGE_TOP
	,SHAD1_MARGE_RIGHT
	,SHAD1_DAMAGE
	,SHAD1_LIFE
	,SHAD1_SPR_ID_1
	,SHAD1_SPR_ID_2
	,SHAD1_SPR_ID_3
	,SHAD1_SPR_ID_4)
{
	m_stepRnd=12;
	m_stepOffset=32;
	m_stepSpeed=5;

	AddEnemy(ENEMY_FOLOW,m_posX,m_posY);
	AddEnemy(ENEMY_FOLOW,m_posX+8,m_posY);
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CE_Shad1::AutoMove()
{
	switch(m_stateMove)
	{
	case STATE_CHOOSE_DEST:
		m_nbrStep=m_stepOffset+rand()%m_stepRnd;
		m_goDir=rand()%4;
		m_stateMove=STATE_GO_DEST;
		break;
	case STATE_GO_DEST:
		if (globalTimer%m_stepSpeed==0)
		{
			m_nbrStep--;
			if(m_nbrStep==0) m_stateMove=STATE_CHOOSE_DEST;

			if(!MoveTo(m_goDir)) m_goDir=NotDirection();
			if(!MoveTo((m_goDir+1)%4)) m_goDir=NotDirection();
		}
		break;
	}

	return TRUE;
}

void CE_Shad1::Draw()
{				
	switch(m_lifeState)
	{
	case LIFE_STATE_ALIVE:
			m_spr1=GetAniSprItem(m_sprID[DIR_BOTTOM],m_aniLen,m_aniSpeed);
			m_spr2=GetAniSprItem(m_sprID[DIR_LEFT],m_aniLen,m_aniSpeed);
			m_spr3=GetAniSprItem(m_sprID[DIR_TOP],m_aniLen,m_aniSpeed);
			m_spr4=GetAniSprItem(m_sprID[DIR_RIGHT],m_aniLen,m_aniSpeed);
			break;
	case LIFE_STATE_DAMAGE:
			m_spr1=DEFAUT_SPR_EXTRA_ANI_D+m_timerExtraAni;
			m_spr2=m_spr1;
			m_spr3=m_spr1;
			m_spr4=m_spr1;
			m_timerExtraAni++;
			if(m_timerExtraAni==DEFAUT_NBR_SPR_EXTRA_ANI_D) m_lifeState=LIFE_STATE_ALIVE;
			break;
	case LIFE_STATE_KILL:
			m_spr1=DEFAUT_SPR_EXTRA_ANI_K+m_timerExtraAni;
			m_spr2=m_spr1;
			m_spr3=m_spr1;
			m_spr4=m_spr1;
			m_timerExtraAni++;
			if(m_timerExtraAni>=DEFAUT_NBR_SPR_EXTRA_ANI_K) m_lifeState=LIFE_STATE_DIED;
			break;
	}

	DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,m_spr1,SEG1);
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX+8,m_posY-mapPosY,m_spr2,SEG1);
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX+8,m_posY-mapPosY+8,m_spr4,SEG1);
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY+8,m_spr3,SEG1);
}

void CE_Shad1::SetKilled()
{
	if(m_lifeState==LIFE_STATE_KILL) return;

	m_timerExtraAni=0;
	m_lifeState=LIFE_STATE_KILL;

	KillAllInMap(GetMapID());
	AddItem(OBJECT_KEY,m_posX+4,m_posY+4);
}

void CE_Shad1::SetDamaged()
{
	if(hero.m_weapon1==NULL || hero.m_weapon1->m_objectID!=OBJECT_SWORD) return;

	m_timerExtraAni=0;
	m_lifeState=LIFE_STATE_DAMAGE;
	AddEnemy(ENEMY_FOLOW,m_posX,m_posY);
	AddEnemy(ENEMY_FOLOW,m_posX+8,m_posY);
}

char CE_Shad1::IncLife(char inc)
{
	if(hero.m_weapon1==NULL || hero.m_weapon1->m_objectID!=OBJECT_SWORD) return 1;

	m_life+=inc;

	return m_life;
}
