/**
* @package Enemies
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CE_Shad1.h						*
 *													*
 *	Header for CE_Shad1.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CE_SHAD1
#define CE_SHAD1

#include "Types2.h"
#include "CEnemy.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define SHAD1_DAMAGE			-1
#define SHAD1_LIFE				10


#define SHAD1_SPR_ID_1			40	
#define SHAD1_SPR_ID_2			42
#define SHAD1_SPR_ID_3			44
#define SHAD1_SPR_ID_4			46
#define SHAD1_ANI_LEN			2
#define SHAD1_ANI_SPEED1		15
#define SHAD1_ANI_SPEED2		16
#define SHAD1_ANI_SPEED3		17
#define SHAD1_ANI_SPEED4		18


#define	SHAD1_MARGE_BOTTOM		-8
#define	SHAD1_MARGE_LEFT		1
#define	SHAD1_MARGE_TOP			1
#define	SHAD1_MARGE_RIGHT		-8

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Class Shad'Ow Enemy which create a Boss 16*16pixels with 4 sprites 8*8
*/
class  CE_Shad1 : public CEnemy
{

public:
	/**
	* Standard constructor
	* @see CEnemy#CEnemy()
	*/
	CE_Shad1(short initX, short initY);

public:
	/**
	* First corner of sprite
	*/
	uchar m_spr1;
	/**
	* Second corner of sprite
	*/
	uchar m_spr2;
	/**
	* Third corner of sprite
	*/

	uchar m_spr3;
	/**
	* Fourth corner of sprite
	*/
	uchar m_spr4;

public:
	/**
	* Simple diagonal move without AI
	*/
	BOOL AutoMove();
	/**
	* When killed, this boss give a key type 1
	*/
	void SetKilled();
	/**
	* When damaged, with sword only, this boss create 2 Follower Enemies
	*/
	void SetDamaged();
	/**
	* IncLife enable if only weapon is the sword
	*/
	char IncLife(char inc);

	/**
	* Special for drawing 16*16 sprite from 8*8 sprites
	*/
	void Draw();
};

#endif