/**
* @package Enemies
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CE_Wall.h						*
 *													*
 *	Header for CE_Wall.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CE_WALL
#define CE_WALL

#include "Types2.h"
#include "CEnemy.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define WALL_DAMAGE				-4
#define WALL_LIFE				5


#define WALL_SPR_ID_ALL			48	
#define WALL_ANI_LEN			2	

#define	WALL_MARGE_BOTTOM		1
#define	WALL_MARGE_LEFT			1
#define	WALL_MARGE_TOP			1
#define	WALL_MARGE_RIGHT		1

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Class Wall Enemy which is an enemy who jump
*/
class CE_Wall : public CEnemy
{

public:
	/**
	* Standard constructor
	* @see CEnemy#CEnemy()
	*/
	CE_Wall(short initX, short initY);

public:
	/**
	* Move on wall
	* @see CEnemy#AutoMove()
	*/
	BOOL AutoMove();
	/**
	* Can only be damaged with arrows
	*/
	void SetDamaged();
	/**
	* IncLife enable if only weapon is the arrows
	*/
	char IncLife(char inc);


};

#endif