/****************************************************
 *	Original name : CEnemy.cpp						*
 *													*
 *	Class for using enemy.							*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CEnemy.h"
#include "Data.h"
#include "DrwSprSW.h"
#include "Map.h"
/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CEnemy::CEnemy(uchar objID, short initX, short initY
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, char damage
		, char life
		, uchar sprBottom
		, uchar sprLeft
		, uchar sprTop
		, uchar sprRight
		, char aniLen
		, char aniSpeed)
	:CPerso(objID, initX, initY
		, margeBottom
		, margeLeft
		, margeTop
		, margeRight
		, sprBottom
		, sprLeft
		, sprTop
		, sprRight
		, life
		, aniLen
		, aniSpeed)
{
	m_timerEnable=0;

	m_stateMove=STATE_CHOOSE_DEST;
	m_stepRnd=8;
	m_stepOffset=8;
	m_stepSpeed=4;
	m_dirRnd=4;

	m_lifeState=LIFE_STATE_ALIVE;

	m_damage=damage;
	m_life=life;
}

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

BOOL CEnemy::AutoMove()
{
	switch(m_stateMove)
	{
	case STATE_CHOOSE_DEST:
		m_nbrStep=m_stepOffset+rand()%m_stepRnd;
		m_goDir=rand()%m_dirRnd;
		m_stateMove=STATE_GO_DEST;
		break;
	case STATE_GO_DEST:
		if (globalTimer%m_stepSpeed==0)
		{
			if(m_nbrStep==0) m_stateMove=STATE_CHOOSE_DEST;
			m_nbrStep--;

			if(!MoveTo(m_goDir)) return FALSE;
		}
		break;
	}

	return TRUE;
}

void CEnemy::SetKilled()
{
	if(m_lifeState==LIFE_STATE_KILL) return;

	m_timerExtraAni=0;
	m_lifeState=LIFE_STATE_KILL;
}

void CEnemy::SetDamaged()
{
	m_timerExtraAni=0;
	m_lifeState=LIFE_STATE_DAMAGE;
}

char CEnemy::IncLife(char inc)
{
	m_life+=inc;

	return m_life;
}

/********************************************************************************
 *																				*
 *						inline Class methodes									*
 *																				*
 ********************************************************************************/

void CEnemy::SetEnable()
{
	CBaseSpr::SetEnable();

	m_timerEnable=0;
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/


void CEnemy::Draw()
{
	switch(m_lifeState)
	{
	case LIFE_STATE_ALIVE:
			DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,GetAniSprItem(m_sprID[m_direction], m_aniLen, m_aniSpeed),SEG1);
			break;
	case LIFE_STATE_DAMAGE:
			DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,DEFAUT_SPR_EXTRA_ANI_D+m_timerExtraAni/DEFAUT_EXTRA_ANI_SPEED_D,SEG1);
			
			m_timerExtraAni++;
			if(m_timerExtraAni==DEFAUT_NBR_SPR_EXTRA_ANI_D) m_lifeState=LIFE_STATE_ALIVE;
			break;
	case LIFE_STATE_KILL:
			DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,DEFAULT_SPR_SHADOW,SEG1);
			DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY-m_timerExtraAni/DEFAUT_EXTRA_ANI_SPEED_K,DEFAUT_SPR_EXTRA_ANI_K+m_timerExtraAni/DEFAUT_EXTRA_ANI_SPEED_K,SEG1);
			
			m_timerExtraAni++;
			if(m_timerExtraAni==DEFAUT_NBR_SPR_EXTRA_ANI_K) 
			{
				m_lifeState=LIFE_STATE_DIED;
				GenerateRndItem(m_posX,m_posY);
			}
			break;
	}
}

BOOL CEnemy::CountDisable()
{
	if(m_timerEnable<TIME_ENABLE)
	{
		m_timerEnable++;
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}