/**
* @package Hero
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CHero.h							*
 *													*
 *	Header for CHero.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CHERO
#define CHERO

#include "Types2.h"
#include "CPerso.h"
#include "CWeapon.h"
#include "CLinkedS.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define HERO_SPR_ID_BOTTOM		0	
#define HERO_SPR_ID_LEFT		2
#define HERO_SPR_ID_TOP			4
#define HERO_SPR_ID_RIGHT		6

#define HERO_ANI_LEN			2
#define HERO_ANI_SPEED			5

#define	HERO_MARGE_BOTTOM		1
#define	HERO_MARGE_LEFT			2
#define	HERO_MARGE_TOP			3
#define	HERO_MARGE_RIGHT		2

#define TIME_GHOST				32
#define TIME_PUSHING			16

#define SCAN_NOTHING			0
#define SCAN_STOP				1
#define SCAN_WATER				2

/********************************************************************************
 *																				*
 *						Hero functions											*
 *																				*
 ********************************************************************************/
/**
* Test square property and execute action (ex: display text, jump, save game...)
*/
extern void TestAction();
/**
* Make Kliz fly
* @param posX position x of destination
* @param posY position y of destination
* @param scanSquare can be a combinaison of SCAN_STOP, SCAN_WATER to avoid fly over STOP or WATER squares
*/
extern void FlyTo(short posX, short posY, char scanSquare=SCAN_NOTHING /*default*/);
/**
* Make Kliz pay
* @param value money wanted
* @return TRUE if Kliz can pay
*/
extern BOOL Pay(uchar value);
/**
* Wipe Kliz inventory
*/
extern void WipeInvHero();

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/
/**
* Kliz class, Hero of Shadow World
*/
class CHero : public CPerso
{

public:
	/**
	* Standard constructor
	* @see CPerso#CPerso
	*/
	CHero(short initX, short initY);

public:
	char m_maxLife;
	short m_safePosX;
	short m_safePosY;
	char m_timerGhost;
	BOOL m_ghost;
	CWeapon* m_weapon1;
	CWeapon* m_weapon2;
	CLinkedSprites m_listItems;
	CLinkedSprites m_listWeapons;
	uchar m_lastProp;
	BOOL m_haveMoved;

public:
	void Draw();
	BOOL MoveTo(uchar tDir);
	BOOL CanMove();
	void SetGhost();

	char IncLife(char inc);
};

#endif	
