/****************************************************
 *	Original name : CI_Buyer.cpp					*
 *													*
 *	Class for buying objects.						*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CI_Buyer.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "CHero.h"
#include "LoadFile.h"
#include "System2.h"
#include "Keys.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CI_Buyer::CI_Buyer(short initX, short initY)
	:CItem(OBJECT_BUYER, initX, initY
	, BUYER_MARGE_BOTTOM
	,BUYER_MARGE_LEFT
	,BUYER_MARGE_TOP
	,BUYER_MARGE_RIGHT
	,BUYER_SPR_ID
	,BUYER_ANI_LEN
	,BUYER_ANI_SPEED)
{
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/	

BOOL CI_Buyer::Action()
{
	if(!Touche(KEY_ACTION)) return FALSE;

	uchar price;
	uchar article=DisplayTextWindow(DISP_WND_TOP,LoadText(TEXT_BUYER_1));

	switch(article)
	{
	case CHOOSE_1:	//heart
		price=30;
		break;
	case CHOOSE_2:	//arrows
		price=10;
		break;
	case CHOOSE_3:	//bombs
		price=20;
		break;
	default:
		return FALSE;
	}

	sprintf(curText,"This article costs\n%u \\. Ok?\n1-Yes, 2-No",price);

	if(DisplayTextWindow(DISP_WND_TOP,curText)==CHOOSE_1)
	{
		if(Pay(price))
		{
			switch(article)
			{
			case CHOOSE_1:	//heart
				AddHeroItem(OBJECT_HEART,1);
				break;
			case CHOOSE_2:	//arrows
				AddHeroWeapon(OBJECT_ARROW,10);
				break;
			case CHOOSE_3:	//bombs
				AddHeroWeapon(OBJECT_BOMB,10);
				break;
			}
		}
	}

	return FALSE;
}