/****************************************************
 *	Original name : CI_Lock.cpp						*
 *													*
 *	Class for using lock bloc.						*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CI_Lock.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "CHero.h"
#include "LoadFile.h"
#include "CLinkedS.h"
#include "System2.h"
#include "Keys.h"
/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CI_Lock::CI_Lock(uchar lockCode, short initX, short initY)
	:CItem(lockCode, initX, initY
	, LOCK_MARGE_BOTTOM
	,LOCK_MARGE_LEFT
	,LOCK_MARGE_TOP
	,LOCK_MARGE_RIGHT
	,LOCK_SPR_ID
	,LOCK_ANI_LEN)
{
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/	

BOOL CI_Lock::Action()
{
	if(!Touche(KEY_ACTION)) return FALSE;

	BOOL okForOpen=FALSE;
	CNode* curNode;
	
	for(curNode=hero.m_listItems.m_head; curNode!=NULL; curNode=curNode->m_next)
	{
		if((m_objectID-OBJECT_KEY)==(((CItem*)curNode->m_sprite)->m_objectID-OBJECT_LOCK))
		{
			okForOpen=TRUE;
			break;
		}
	}

	if(!okForOpen)
	{
		if(DisplayTextWindow(DISP_WND_TOP,LoadText(TEXT_HELP_OBJECT+m_objectID))==CHOOSE_1)
		{
			DisplayTextWindow(DISP_WND_BOTTOM,LoadText(TEXT_DONT_GO));
		}
		return FALSE;
	}

	short tmpPosY=m_posY;

	for(uchar i=0; i<32; i++)
	{
		SetPos(m_posX,tmpPosY+rand()%4-1);
		DrawScene();
		SwapPage();
		Wait(10);
	}

	//unlock square
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_TERRAN);

	//key -1
	((CItem*) curNode->m_sprite)->m_extra--;
	WipeInvHero();

	return TRUE;
}

void CI_Lock::Draw()
{
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);
	CItem::Draw();
}