/****************************************************
 *	Original name : CI_Plant.cpp					*
 *													*
 *	Class for using sword plant.					*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CI_Plant.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "CHero.h"
#include "LoadFile.h"
#include "CLinkedS.h"
#include "System2.h"

 /********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CI_Plant::CI_Plant(short initX, short initY)
	:CItem(OBJECT_PLANT, initX, initY
	, PLANT_MARGE_BOTTOM
	,PLANT_MARGE_LEFT
	,PLANT_MARGE_TOP
	,PLANT_MARGE_RIGHT
	,PLANT_SPR_ID
	,PLANT_ANI_LEN
	,PLANT_ANI_SPEED)
{
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);

	m_isCut=FALSE;
	m_timer=0;
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/	

BOOL CI_Plant::Action()
{
	return m_isCut;
}

void CI_Plant::Draw()
{
	if(m_timer==0) 
	{
		CItem::Draw();
		
		if(hero.m_weapon1==NULL) return;
		
		if(hero.m_weapon1->m_objectID!=OBJECT_SWORD && hero.m_weapon1->m_objectID!=OBJECT_BOOMG) return;
		
		if(hero.m_weapon1->IsEnable() && TestCollision((CSprite*) hero.m_weapon1))
		{
			SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_TERRAN);
			
			//enable collision with hero
			SetMarginRect(PLANT_MARGE_BOTTOM-32,PLANT_MARGE_LEFT-32,PLANT_MARGE_TOP-32,PLANT_MARGE_RIGHT-32);
			m_timer++;
		}
	}
	else
	{
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,DEFAULT_SPR_EXPLODE+m_timer/2,SEG1);
		
		if(m_timer==15)
		{
			m_isCut=TRUE;
			GenerateRndItem(m_posX,m_posY);
		}

		m_timer++;
	}
}
