/****************************************************
 *	Original name : CI_Push.cpp						*
 *													*
 *	Class for using push bloc.						*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CI_Push.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "CHero.h"
#include "Keys.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CI_Push::CI_Push(short initX, short initY)
	:CItem(OBJECT_PUSH, initX, initY
	, PUSH_MARGE_BOTTOM
	,PUSH_MARGE_LEFT
	,PUSH_MARGE_TOP
	,PUSH_MARGE_RIGHT
	,PUSH_SPR_ID
	,PUSH_ANI_LEN)
{
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);
	m_timerEnable=TIME_4VAR_OFFSET;
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/	

void CI_Push::Slide(char direction)
{
	char incX=0;
	char incY=0;

	switch(direction)
	{
	case DIR_BOTTOM:
		incY=1;
		break;
	case DIR_RIGHT:
		incX=1;
		break;
	case DIR_TOP:
		incY=-1;
		break;
	case DIR_LEFT:
		incX=-1;
		break;
	}

	uchar tmpProp=GetProp(PosPxToCase(m_posX+incX*8,m_posY+incY*8));

	if(tmpProp==P_WATER || tmpProp==P_STOP || tmpProp==P_STOP_PUSH) return;

	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_TERRAN);


	//draw mark on the floor
	if(direction==DIR_BOTTOM || direction==DIR_TOP) direction=PUSH_SPR_DEGRAD_V;
	else direction=PUSH_SPR_DEGRAD_H;
	SetSpr(PosPxToCase(M_POS_Xc,M_POS_Yc),direction);	//we use direction for temp variable

	for(uchar i=0; i<8; i++)
	{
		DrawScene();
		SetPos(m_posX+incX,m_posY+incY);
		SwapPage();
	}

	//test target object
	if(tmpProp==OBJECT_TARGET_P) KillAllInMap(GetMapID(),ENEMY_BLOC);
	
	SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);
}

BOOL CI_Push::Action()
{
	if(hero.m_haveMoved==TRUE) m_timerEnable++;
	else m_timerEnable=TIME_4VAR_OFFSET;

	if(m_timerEnable<TIME_4VAR_OFFSET+16) return FALSE;

	m_timerEnable=TIME_4VAR_OFFSET;

	//verify the direction for sliding...
	switch(hero.m_direction)
	{
	case DIR_BOTTOM:
		if(m_posY<hero.m_posY+8) return FALSE;
		break;
	case DIR_RIGHT:
		if(m_posX<hero.m_posX+7) return FALSE;
		break;
	case DIR_TOP:
		if(m_posY>hero.m_posY) return FALSE;
		break;
	case DIR_LEFT:
		if(m_posX>hero.m_posX) return FALSE;
		break;
	}

	Slide(hero.m_direction);

	return FALSE;
}