/****************************************************
 *	Original name : CItem.cpp						*
 *													*
 *	Class for using items.							*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CItem.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "LoadFile.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CItem::CItem(uchar objID, short initX, short initY
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, uchar sprID
		, char aniLen
		, char aniSpeed)
	:CSprite(objID, initX, initY
	, margeBottom
	, margeLeft
	, margeTop
	, margeRight)
{
	m_timerEnable=TIME_NONE;

	m_sprID=sprID;
	m_aniLen=aniLen;
	m_aniSpeed=aniSpeed;

	m_extra=1;
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

void CItem::Draw()
{
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,GetAniSprItem(m_sprID,m_aniLen,m_aniSpeed),SEG1);
}

BOOL CItem::Action()
{
	AddHeroItem(m_objectID);

	return TRUE;
}

BOOL CItem::Use()
{
	DisplayTextWindow(DISP_WND_BOTTOM,LoadText(TEXT_ITEM_NOT_USE),FALSE);

	return FALSE;
}


BOOL CItem::MoveTo(uchar tDir)
{
	if(tDir>DIR_RIGHT) return FALSE;	//invalid direction

	switch(tDir)
	{
	case DIR_BOTTOM:
		SetPos(m_posX, m_posY+1);
		break;
	case DIR_LEFT:
		SetPos(m_posX-1, m_posY);
		break;
	case DIR_TOP:
		SetPos(m_posX, m_posY-1);
		break;
	case DIR_RIGHT:
		SetPos(m_posX+1, m_posY);
		break;
	}

	return TRUE;
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CItem::CountDisable()
{
	if(m_timerEnable>=TIME_NONE) return FALSE;

	if(m_timerEnable<TIME_ENABLE)
	{
		m_timerEnable++;
		return FALSE;
	}
	else
	{
		return TRUE;
	}
}