/**
* @package Items
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CItem.h							*
 *													*
 *	Header for CItem.cpp							*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CITEM
#define CITEM

#include "Types2.h"
#include "CSprite.h"
#include "Graphic.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define ITEM_MARGE_BOTTOM		2
#define ITEM_MARGE_RIGHT		2
#define ITEM_MARGE_LEFT			2
#define ITEM_MARGE_TOP			2
#define DEFAULT_ITEM_ANI_LEN	4

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

class CItem : public CSprite
{

public:
	CItem(uchar objID, short initX, short initY
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, uchar sprID
		, char aniLen=DEFAULT_ITEM_ANI_LEN
		, char aniSpeed=DEFAULT_ANI_SPEED);

public:
	uchar m_sprID;		//ID of sprites
	char m_aniLen;
	char m_aniSpeed;

public:
	virtual void Draw();
	/**
	*	return TRUE if it must be deleted
	*/
	virtual BOOL Action();
	virtual BOOL Use();

	BOOL CountDisable();

	virtual BOOL MoveTo(uchar tDir);

};

#endif