/**
* @package Sprites
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CLinkedS.h						*
 *													*
 *	Header for CLinkedS.cpp							*
 *	Class of LinkedList of sprites.					*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CLINKEDS
#define CLINKEDS

#include "Types2.h"
#include "CBaseSpr.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class CNode Declarations (use in CLinkedSprites class)	*
 *																				*
 ********************************************************************************/

class CNode
{

public:
	CNode();

public:
	CBaseSpr* m_sprite;
	CNode* m_next;

public:

};

/********************************************************************************
 *																				*
 *						Class CLinkedSprites Declarations						*
 *																				*
 ********************************************************************************/

class CLinkedSprites
{

public:
	CLinkedSprites();

public:
	CNode* m_head;
	CNode* m_tail;

public:
	CBaseSpr* AddSprite(CBaseSpr* ptSpr);
	CNode* DeleteSprite(CNode* ptNode);
	BOOL IsEmpty();
	uchar CountSprite();
	uchar GetIndice(CBaseSpr* ptSpr);
	CBaseSpr* GetSprite(uchar indice);

	void DeleteAll();
};

#endif