/****************************************************
 *	Original name : CPerso.cpp						*
 *													*
 *	Class for using perso.							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 ****************************************************/
#include "CPerso.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CPerso::CPerso(uchar objID, short initX, short initY
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, uchar sprBottom
		, uchar sprLeft
		, uchar sprTop
		, uchar sprRight
		, char life
		, char aniLen
		, char aniSpeed)
	:CSprite(objID, initX, initY, margeBottom, margeLeft, margeTop, margeRight)
{
	m_direction=DIR_BOTTOM;

	//initialization of animation
	m_sprID[DIR_BOTTOM]	=sprBottom;
	m_sprID[DIR_LEFT]	=sprLeft;
	m_sprID[DIR_TOP]	=sprTop;
	m_sprID[DIR_RIGHT]	=sprRight;

	m_aniLen=aniLen;
	m_aniSpeed=aniSpeed;

	m_life=life;
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

void CPerso::Draw()
{
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,GetAniSprItem(m_sprID[m_direction], m_aniLen, m_aniSpeed),SEG1);
}

BOOL CPerso::CanMove()
{
	switch(PropIs())
	{
	case P_STOP:case P_WATER:case P_KILLER12:case P_KILLER:
		return FALSE;
	}

	//default
	return TRUE;
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CPerso::MoveTo(uchar tDir)
{
	if(tDir>DIR_RIGHT) return FALSE;	//invalid direction

	//keep current position
	short keepPosX=m_posX;
	short keepPosY=m_posY;

	//update temporary position
	switch(tDir)
	{
	case DIR_BOTTOM:
		m_posY++;
		break;
	case DIR_LEFT:
		m_posX--;
		break;
	case DIR_TOP:
		m_posY--;
		break;
	case DIR_RIGHT:
		m_posX++;
		break;
	}

	//update orientation
	m_direction=tDir;
	
	if(!CanMove()
		|| !IsInMap())	//if we can't move, we reload last position
	{
		SetPos(keepPosX, keepPosY);
		return FALSE;
	}

	return TRUE;
}

uchar CPerso::NotDirection()
{
	return (m_direction+2)%4;
}
