/**
* @package Sprites
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CPerso.h						*
 *													*
 *	Header for CPerso.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CPERSO
#define CPERSO

#include "Types2.h"
#include "CSprite.h"
#include "Graphic.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

class CPerso : public CSprite
{

public:
	CPerso(uchar objID, short initX, short initY
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, uchar sprBottom
		, uchar sprLeft
		, uchar sprTop
		, uchar sprRight
		, char life
		, char aniLen
		, char aniSpeed=DEFAULT_ANI_SPEED);
public:
	char m_life;
	uchar m_sprID[4];	//ID of sprites for each direction
	char m_aniLen;
	char m_aniSpeed;
	uchar m_direction;

public:
	virtual void Draw();
	virtual BOOL CanMove();

	virtual BOOL MoveTo(uchar tDir);
	uchar NotDirection();
};

#endif