/****************************************************
 *	Original name : CSprite.cpp						*
 *													*
 *	Class for using sprites.						*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 ****************************************************/

#include "CSprite.h"
#include "System2.h"	//for min/max functions
#include "Data.h"
#include "Map.h"
#include <mem.h>

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CSprite::CSprite(uchar objID, short initX, short initY
				 , char margeBottom
				 , char margeLeft
				 , char margeTop
				 , char margeRight)
	:CBaseSpr(objID, initX, initY)
{
	SetMarginRect(margeBottom,margeLeft,margeTop,margeRight);
	
	m_myMapID=GetMapID();
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

BOOL CSprite::TestCollision(CSprite* tSpr)
{
	if(max(m_posX+m_marginRect.left, tSpr->m_posX+tSpr->m_marginRect.left)<=min(m_posX+8-m_marginRect.right, tSpr->m_posX+8-tSpr->m_marginRect.right)
		&& max(m_posY+m_marginRect.top, tSpr->m_posY+tSpr->m_marginRect.top)<=min(m_posY+8-m_marginRect.bottom, tSpr->m_posY+8-tSpr->m_marginRect.bottom)) return TRUE;

	return FALSE;
}

void CSprite::SetMarginRect(char margeBottom, char margeLeft, char margeTop, char margeRight)
{
	m_marginRect.bottom=margeBottom;
	m_marginRect.left=margeLeft;
	m_marginRect.top=margeTop;
	m_marginRect.right=margeRight;
}

uchar CSprite::PropIs()
{
	uchar returnProp=P_TERRAN;
	uchar testProp;

	//corner 1
	testProp=GetProp(PosPxToCase(m_posX+m_marginRect.left,m_posY+m_marginRect.top));
	returnProp=TestProp(testProp, returnProp);

	//corner 2
	testProp=GetProp(PosPxToCase(m_posX+m_marginRect.left,m_posY+8-m_marginRect.bottom));
	returnProp=TestProp(testProp, returnProp);

	//corner 3
	testProp=GetProp(PosPxToCase(m_posX+8-m_marginRect.right,m_posY+m_marginRect.top));
	returnProp=TestProp(testProp, returnProp);

	//corner 4
	testProp=GetProp(PosPxToCase(m_posX+8-m_marginRect.right,m_posY+8-m_marginRect.bottom));
	returnProp=TestProp(testProp, returnProp);

	return returnProp;
}

BOOL CSprite::IsInMap()
{
	if(m_posX+m_marginRect.left<0) return FALSE;
	if(m_posY+m_marginRect.top<0) return FALSE;
	if(m_posX+8-m_marginRect.right>=dimMapPxX) return FALSE;
	if(m_posY+8-m_marginRect.bottom>=dimMapPxY) return FALSE;

	return TRUE;
}
