/**
* @package Sprites
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CSprite.h						*
 *													*
 *	Header for CSprite.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CSPRITE
#define CSPRITE

#include "Types2.h"
#include "Graphic.h"
#include "CBaseSpr.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

class CSprite : public CBaseSpr
{

public:
	CSprite(uchar objID, short initX, short initY, char margeBottom, char margeLeft, char margeTop, char margeRight);

public:
	StructRect_c m_marginRect;
	uchar m_myMapID;
	ushort m_timerEnable;
	uchar m_extra;

public:
	void SetMarginRect(char margeBottom, char margeLeft, char margeTop, char margeRight); //set the margin with dimensions for testing collision

	uchar PropIs();		//test the four corners of m_testRect and return Prop with priority for P_STOP
	BOOL IsInMap();

	//virtual methodes
	virtual BOOL TestCollision(CSprite* tSpr);
};

#endif