/****************************************************
 *	Original name : CW_Arrow.cpp					*
 *													*
 *	Class for using arrow.							*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CW_Arrow.h"
#include "CEnemy.h"
#include "Data.h"
#include "Map.h"
#include "CLinkedS.h"

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CW_Arrow::CW_Arrow()
	:CWeapon(OBJECT_ARROW
	,ARROW_MARGE_BOTTOM
	,ARROW_MARGE_LEFT
	,ARROW_MARGE_TOP
	,ARROW_MARGE_RIGHT
	,ARROW_SPR_ID_BOTTOM
	,ARROW_SPR_ID_LEFT
	,ARROW_SPR_ID_TOP
	,ARROW_SPR_ID_RIGHT
	,ARROW_DAMAGE)
{
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

void CW_Arrow::StateActionStart()
{
	if(m_extra==0) return;
	m_extra--;

	CWeapon::StateActionStart();

	SetPos(hero.m_posX, hero.m_posY);

	m_incx=0;
	m_incy=0;

	switch(m_direction)
	{
	case DIR_BOTTOM:
		m_incy=ARROW_STEP;
		break;
	case DIR_LEFT:
		m_incx=-ARROW_STEP;
		break;
	case DIR_TOP:
		m_incy=-ARROW_STEP;
		break;
	case DIR_RIGHT:
		m_incx=ARROW_STEP;
		break;
	}
}

void CW_Arrow::StateActionRun()
{
	//move the arraw
	SetPos(m_posX+m_incx, m_posY+m_incy);
	
	//test out of map
	if(!IsInMap()) StateActionForceEnd();
	
	switch(PropIs())
	{
	case P_STOP:
		StateActionForceEnd();
		break;
	case OBJECT_TARGET_W:
		KillAllInMap(GetMapID(),ENEMY_BLOC);
		StateActionForceEnd();
		break;
	}

	m_timerLifeRun++;
}

