/****************************************************
 *	Original name : CW_Bomb.cpp						*
 *													*
 *	Class for using bomb.							*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CW_Bomb.h"
#include "Data.h"
#include "Map.h"
#include "DrwSprSW.h"
#include "Draw.h"
#include "Keys.h"
#include "SW.h"
/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CW_Bomb::CW_Bomb()
	:CWeapon(OBJECT_BOMB,8,8,8,8 //no collision at init
	,BOMB_SPR_ID
	,BOMB_SPR_ID
	,BOMB_SPR_ID
	,BOMB_SPR_ID
	,BOMB_DAMAGE)	
{
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

void CW_Bomb::StateActionStart()
{
	if(m_extra==0) return;
	m_extra--;

	CWeapon::StateActionStart();

	SetPos(hero.m_posX, hero.m_posY);

	m_incx=0;
	m_incy=0;

	switch(m_direction)
	{
	case DIR_BOTTOM:
		m_incy=BOMB_STEP;
		break;
	case DIR_LEFT:
		m_incx=-BOMB_STEP;
		break;
	case DIR_TOP:
		m_incy=-BOMB_STEP;
		break;
	case DIR_RIGHT:
		m_incx=BOMB_STEP;
		break;
	}

	//disable collision
	SetMarginRect(8,8,8,8);
	
	m_slide=TRUE;
}

void CW_Bomb::StateActionRun()
{
	//move the bomb
	if(m_timerLifeRun%BOMB_SPEED==0 && m_timerLifeRun<=BOMB_TIMER_STOP)
	{
		if(m_slide && Touche(KEY_WEAPON_1))
		{
			SetPos(m_posX+m_incx, m_posY+m_incy);
			
			SetMarginRect(BOMB_MARGE_BOTTOM,BOMB_MARGE_LEFT,BOMB_MARGE_TOP,BOMB_MARGE_RIGHT);
			switch(PropIs())
			{
			case P_STOP:
				m_incx=-m_incx;
				m_incy=-m_incy;
				SetPos(m_posX+m_incx, m_posY+m_incy);
				break;
			case P_WATER:
				CWeapon::StateActionForceEnd();
				break;
			}
			SetMarginRect(8,8,8,8);
		}
		else m_slide=FALSE;
	}

	//BOOOMMM the bomb !!!
	if(m_timerLifeRun==BOMB_TIMER_BOOM)
	{
		//enable collision
		SetMarginRect(BOMB_MARGE_BOTTOM-BOMB_AREA,BOMB_MARGE_LEFT-BOMB_AREA,BOMB_MARGE_TOP-BOMB_AREA,BOMB_MARGE_RIGHT-BOMB_AREA);
	}

	//test collision with hero
	if(m_timerLifeRun>=BOMB_TIMER_BOOM)
	{
		if(TestCollision((CSprite*) &hero))
		{
			hero.IncLife(m_damage);
			hero.SetGhost();
		}
	}

	if(m_timerLifeRun==BOMB_TIMER_BOOM_LEN) CWeapon::StateActionForceEnd();

	m_timerLifeRun++;
}

void CW_Bomb::Draw()
{
	if(m_timerLifeRun<BOMB_TIMER_BOOM)
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,BOMB_SPR_ID,SEG1);
	else
	{
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX-3,m_posY-mapPosY-3,BOMB_SPR_ID_BOOM+m_timerLifeRun%BOMB_SPR_ID_BOOM_LEN,SEG1);
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX-3,m_posY-mapPosY+3,BOMB_SPR_ID_BOOM+m_timerLifeRun%BOMB_SPR_ID_BOOM_LEN,SEG1);
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX+3,m_posY-mapPosY-3,BOMB_SPR_ID_BOOM+m_timerLifeRun%BOMB_SPR_ID_BOOM_LEN,SEG1);
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX+3,m_posY-mapPosY+3,BOMB_SPR_ID_BOOM+m_timerLifeRun%BOMB_SPR_ID_BOOM_LEN,SEG1);
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,BOMB_SPR_ID_BOOM+m_timerLifeRun%BOMB_SPR_ID_BOOM_LEN,SEG1);
	}
}

void CW_Bomb::StateActionForceEnd()
{
	//nothing... bomb can kill more than one enemy
}
