/**
* @package Weapons
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CW_Bomb.h						*
 *													*
 *	Header for CW_Bomb.cpp							*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CW_BOMB
#define CW_BOMB

#include "Types2.h"
#include "CWeapon.h"
#include "CPerso.h"		//for MoveTo method

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define BOMB_DAMAGE				-2

#define BOMB_SPR_ID				152
#define BOMB_SPR_ID_BOOM		128
#define BOMB_SPR_ID_BOOM_LEN	8

#define	BOMB_MARGE_BOTTOM		2
#define	BOMB_MARGE_LEFT			2
#define	BOMB_MARGE_TOP			2
#define	BOMB_MARGE_RIGHT		2

#define	BOMB_SPEED				2
#define	BOMB_STEP				1
#define	BOMB_TIMER_STOP			48
#define	BOMB_TIMER_BOOM			BOMB_TIMER_STOP+16
#define	BOMB_TIMER_BOOM_LEN		BOMB_TIMER_BOOM+12
#define	BOMB_AREA				8

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

class CW_Bomb : public CWeapon
{

public:
	CW_Bomb();

public:
	char m_incx;
	char m_incy;
	BOOL m_slide;

public:
	void StateActionStart();
	void StateActionRun();
	void StateActionForceEnd();

	void Draw();
};

#endif