/****************************************************
 *	Original name : CW_Boomg.cpp					*
 *													*
 *	Class for using boomerang.						*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CW_Boomg.h"
#include "Data.h"
#include "Map.h"
#include "CLinkedS.h"

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CW_Boomg::CW_Boomg()
	:CWeapon(OBJECT_BOOMG
	,BOOMG_MARGE_BOTTOM
	,BOOMG_MARGE_LEFT
	,BOOMG_MARGE_TOP
	,BOOMG_MARGE_RIGHT
	,BOOMG_SPR_ID_BOTTOM
	,BOOMG_SPR_ID_LEFT
	,BOOMG_SPR_ID_TOP
	,BOOMG_SPR_ID_RIGHT
	,BOOMG_DAMAGE)
{
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

void CW_Boomg::StateActionStart()
{
	CWeapon::StateActionStart();

	m_inc=0;
	m_keepDir=m_direction;

	switch(m_keepDir)
	{
	case DIR_BOTTOM:
		SetPos(hero.m_posX,hero.m_posY+4);
		m_inc=BOOMG_STEP;
		break;
	case DIR_LEFT:
		SetPos(hero.m_posX-4,hero.m_posY-2);
		m_inc=-BOOMG_STEP;
		break;
	case DIR_TOP:
		SetPos(hero.m_posX,hero.m_posY-4);
		m_inc=-BOOMG_STEP;
		break;
	case DIR_RIGHT:
		SetPos(hero.m_posX+4,hero.m_posY-2);
		m_inc=BOOMG_STEP;
		break;
	}

	m_internState=STATE_LAUNCH;
}

void CW_Boomg::StateActionRun()
{
	//move the boomerang
	switch(m_keepDir)
	{
	case DIR_BOTTOM:
		SetPos(hero.m_posX, m_posY+m_inc);
		break;
	case DIR_LEFT:
		SetPos(m_posX+m_inc, hero.m_posY);
		break;
	case DIR_TOP:
		SetPos(hero.m_posX, m_posY+m_inc);
		break;
	case DIR_RIGHT:
		SetPos(m_posX+m_inc, hero.m_posY);
		break;
	}

	switch(m_internState)
	{
	case STATE_LAUNCH:
		//test distance
		if(m_timerLifeRun==BOOMG_DISTANCE) 
		{
			StateActionForceEnd();
			break;
		}

		//test out of map
		if(!IsInMap())
		{
			StateActionForceEnd();
		}
		else 
		{
			switch(PropIs())
			{
			case P_STOP:
				StateActionForceEnd();
				break;
			}
		}

		break;
	case STATE_COMEBACK:
		//test caught items
		for(CNode* curNode=items.m_head; curNode!=NULL; curNode=curNode->m_next)
		{
			if(!curNode->m_sprite->IsEnable()) continue;

			//test collision with boomerang
			if(IsItemForKliz(curNode->m_sprite->m_objectID) && TestCollision((CSprite*)curNode->m_sprite))
			{
				curNode->m_sprite->SetPos(m_posX,m_posY);
			}
		}

		switch(m_keepDir)
		{
		case DIR_BOTTOM:case DIR_TOP:
			if(m_posY>hero.m_posY) m_inc=-BOOMG_STEP;
			if(m_posY<hero.m_posY) m_inc=BOOMG_STEP;
			break;
		case DIR_LEFT:case DIR_RIGHT:
			if(m_posX>hero.m_posX) m_inc=-BOOMG_STEP;
			if(m_posX<hero.m_posX) m_inc=BOOMG_STEP;
			break;
		}
		
		//test arrival
		if(m_posX>hero.m_posX-2 && m_posX<hero.m_posX+2 && m_posY>hero.m_posY-2 && m_posY<hero.m_posY+2)
		{
			CWeapon::StateActionForceEnd();
		}
		break;
	}

	//make the boomerang turn
	m_direction=(globalTimer/2)%4;

	m_timerLifeRun++;
}

void CW_Boomg::StateActionForceEnd()
{
	if(m_internState==STATE_COMEBACK) return;

	m_inc=-m_inc;
	m_internState=STATE_COMEBACK;
}