/****************************************************
 *	Original name : CWeapon.cpp						*
 *													*
 *	Class for using weapon.							*
 *													*
 *													*
 *	June 2003, LeadFiner							*
 ****************************************************/
#include "CWeapon.h"
#include "Data.h"
#include "DrwSprSW.h"
#include "Keys.h"
#include "SW.h"
#include "Map.h"
/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CWeapon::CWeapon(uchar objID
				 , char margeBottom
				 , char margeLeft
				 , char margeTop
				 , char margeRight
				, uchar sprBottom
				, uchar sprLeft
				, uchar sprTop
				, uchar sprRight
				, char damage)
	:CSprite(objID, 0,0, margeBottom, margeLeft, margeTop, margeRight)
{
	m_sprID[DIR_BOTTOM]	=sprBottom;
	m_sprID[DIR_LEFT]	=sprLeft;
	m_sprID[DIR_TOP]	=sprTop;
	m_sprID[DIR_RIGHT]	=sprRight;

	m_stateAction=ACTION_IDLE;
	SetDisable();
	m_extra=1;

	m_damage=damage;
}

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

void CWeapon::Action()
{
	switch(m_stateAction)
	{
	case ACTION_IDLE:
		return;

	case ACTION_RUN:
		StateActionRun();
		break;

	case ACTION_END:
		StateActionEnd();

		if(!Touche(KEY_WEAPON_1) /*&& !Touche(KEY_WEAPON_2)*/) m_stateAction=ACTION_IDLE;
		break;
	}
}

void CWeapon::StateActionStart()
{
	m_direction=hero.m_direction;
	m_timerLifeRun=0;
}

void CWeapon::StateActionRun()
{
}

void CWeapon::StateActionEnd()
{
	SetDisable();
	if(m_extra==0) hero.m_weapon1=NULL;
	WipeInvHero();
}

void CWeapon::StateActionForceEnd()
{
	m_stateAction=ACTION_END;
	StateActionEnd();
}

void CWeapon::Draw()
{
	DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,m_sprID[m_direction],SEG1);
}

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/

void CWeapon::StartAction()
{
	if(m_extra>0 && m_stateAction==ACTION_IDLE)
	{
		StateActionStart();
		SetEnable();

		m_stateAction=ACTION_RUN;
	}
}
