/**
* @package Weapons
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : CWeapon.h						*
 *													*
 *	Header for CWeapon.cpp							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined CWEAPON
#define CWEAPON

#include "Types2.h"
#include "CSprite.h"

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#define ACTION_IDLE		0
#define ACTION_RUN		2
#define ACTION_END		3

/********************************************************************************
 *																				*
 *						Class Declarations										*
 *																				*
 ********************************************************************************/

class CWeapon : public CSprite
{

public:
	CWeapon(uchar objID
		, char margeBottom
		, char margeLeft
		, char margeTop
		, char margeRight
		, uchar sprBottom
		, uchar sprLeft
		, uchar sprTop
		, uchar sprRight
		, char damage);

public:
	char m_stateAction;
	uchar m_timerLifeRun;
	char m_damage;
	uchar m_sprID[4];	//ID of sprites for each direction
	uchar m_direction;

public:
	void StartAction();

	virtual void StateActionStart();
	virtual void StateActionRun();
	virtual void StateActionEnd();
	virtual void StateActionForceEnd();
	virtual void Action();
	virtual void Draw();
};

#endif