/****************************************************
 *	Original name : Data.cpp						*
 *													*
 *	Data definitions.								*
 *	Functions for accessing data.					*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 ****************************************************/

#include "Data.h"
#include "Keys.h"
#include <mem.h>
#include "dos.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

//map
StructMap curMap;
short dimMapX;
short dimMapY;
short dimMapPxX;
short dimMapPxY;
short posMapMaxPxX;
short posMapMaxPxY;
short mapPosX;
short mapPosY;
uchar tabMapEnemyIsScan[MAP_MAX_LOADED];
uchar tabMapItemIsScan[MAP_MAX_LOADED];
CLinkedSprites scenery;
ushort startSquare;

//perso
CHero hero(0,0);

//other
char curText[MAX_CAR];
CLinkedSprites enemies;
CLinkedSprites items;
ushort globalTimer;
char incx=1;
char incy=1;
uchar contrastDB;
uchar contrastC3;
char *curBmpFile;

//inventory
char lastInventory;
char lastInvSel;

//memory zones
memory_zone memSprMap;
memory_zone memSprItem;
memory_zone memSprFont;
memory_zone memBitmap;
memory_zone memSave;
memory_zone memCFG;

//XP system
ushort experience;

/********************************************************************************
 *																				*
 *						Function Declarations									*
 *																				*
 ********************************************************************************/

BOOL AllocMemoryForSpr()
{

	//alloc for Bitmap
	if(!UseMemZone(DEFAULT_MEM_ZONE, DEFAULT_MEM_BITMAP, SIZE_BITMAP+SIZE_ZONE,&memBitmap)) return FALSE;

	//alloc for SpriteFont
	if(!UseMemZone(DEFAULT_MEM_ZONE, DEFAULT_MEM_FONT, SIZE_SPR_FONT+SIZE_ZONE,&memSprFont)) return FALSE;

	//alloc for SpriteItem
	if(!UseMemZone(DEFAULT_MEM_ZONE, DEFAULT_MEM_ITEM, SIZE_SPR_ITEM+SIZE_ZONE,&memSprItem)) return FALSE;

	//alloc for SpriteMap
	if(!UseMemZone(DEFAULT_MEM_ZONE, DEFAULT_MEM_MAP, SIZE_SPR_MAP+SIZE_ZONE,&memSprMap)) return FALSE;
	
	UpdateMemZones();
	return TRUE;
}

void UpdateMemZones()
{
	search_mem_zone(DEFAULT_MEM_ZONE,DEFAULT_MEM_BITMAP,&memBitmap);
	search_mem_zone(DEFAULT_MEM_ZONE,DEFAULT_MEM_FONT,&memSprFont);
	search_mem_zone(DEFAULT_MEM_ZONE,DEFAULT_MEM_ITEM,&memSprItem);
	search_mem_zone(DEFAULT_MEM_ZONE,DEFAULT_MEM_MAP,&memSprMap);
}

BOOL UseMemZone(uchar zoneID, uchar* zoneName, unsigned int zoneSize, struct memory_zone *memZone)
{
	long curSize;

	curSize=search_mem_zone(zoneID,zoneName,memZone);

	if (curSize!=zoneSize)
	{
		if (curSize>1) 
		{
			if(create_mem_zone(zoneID,zoneName,zoneSize,DELETE_ZONE)<0) return FALSE;
		}

		if(create_mem_zone(zoneID,zoneName,zoneSize,CREATE_ZONE)<0) return FALSE;
	}

	search_mem_zone(zoneID,zoneName,memZone);

	return TRUE;
}

void SetMapEnemyIsScan(uchar mapID, BOOL value)
{
	uchar mask=1<<(mapID%8);
	
	if(value)
	{
		tabMapEnemyIsScan[mapID/8]|=mask;
	}
	else
	{
		tabMapEnemyIsScan[mapID/8]&=(0xFF^mask);
	}
}

BOOL GetMapEnemyIsScan(uchar mapID)
{
	uchar mask=1<<(mapID%8);
	
	if((tabMapEnemyIsScan[mapID/8]&mask)==mask)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

void SetMapItemIsScan(uchar mapID, BOOL value)
{
	uchar mask=1<<(mapID%8);
	
	if(value)
	{
		tabMapItemIsScan[mapID/8]|=mask;
	}
	else
	{
		tabMapItemIsScan[mapID/8]&=(0xFF^mask);
	}
}

BOOL GetMapItemIsScan(uchar mapID)
{
	uchar mask=1<<(mapID%8);
	
	if((tabMapItemIsScan[mapID/8]&mask)==mask)
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

