/**
* @package Data
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : Data.h							*
 *													*
 *	Header for Data.cpp								*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/
#if !defined DATA
#define DATA

#include "Types2.h"
#include "CHero.h"
#include "CLinkedS.h"
#include "memzones.h"

/********************************************************************************
 *																				*
 *						Macro definitions										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/

extern void SetMapEnemyIsScan(uchar mapID, BOOL value);
extern BOOL GetMapEnemyIsScan(uchar mapID);
extern void SetMapItemIsScan(uchar mapID, BOOL value);
extern BOOL GetMapItemIsScan(uchar mapID);

//memzones functions
extern BOOL AllocMemoryForSpr();
extern void UpdateMemZones();
extern BOOL UseMemZone(uchar zoneID, uchar* zoneName, unsigned int zoneSize, struct memory_zone *memZone);
/********************************************************************************
 *																				*
 *						Data external Declarations								*
 *																				*
 ********************************************************************************/

//map
extern StructMap curMap;
extern short dimMapX;
extern short dimMapY;
extern short dimMapPxX;
extern short dimMapPxY;
extern short posMapMaxPxX;
extern short posMapMaxPxY;
extern short mapPosX;
extern short mapPosY;
extern uchar tabMapEnemyIsScan[MAP_MAX_LOADED];
extern uchar tabMapItemIsScan[MAP_MAX_LOADED];
extern CLinkedSprites scenery;
extern ushort startSquare;

//perso
extern CHero hero;

//other
extern char curText[MAX_CAR];
extern CLinkedSprites enemies;
extern CLinkedSprites items;
extern ushort globalTimer;
extern char incx;
extern char incy;
extern uchar contrastDB;
extern uchar contrastC3;
extern char *curBmpFile;

//inventory
extern char lastInventory;
extern char lastInvSel;

//memory zones for sprites, bimap and save
extern memory_zone memSprMap;
extern memory_zone memSprItem;
extern memory_zone memSprFont;
extern memory_zone memBitmap;
extern memory_zone memSave;
extern memory_zone memCFG;

/********************************************************************************
 *																				*
 *						Function inline Declarations							*
 *																				*
 ********************************************************************************/

inline uchar GetSpr(ushort indice)
{
	return curMap.tabSpr[indice];
}

inline void SetSpr(ushort indice, uchar nSpr)
{
	curMap.tabSpr[indice]=nSpr;
}

inline uchar GetProp(ushort indice)
{
	return curMap.tabProp[indice];
}

inline void SetProp(ushort indice, uchar nProp)
{
	curMap.tabProp[indice]=nProp;
}

inline StructAni* GetAni(uchar indice)
{
	return &curMap.tabAni[indice];
}

inline uchar GetAniSprItem(uchar indice, char len, char speed)
{
	if(len==0) return indice;

	return indice+(globalTimer/speed)%len;
}

inline StructJump* GetJump(uchar indice)
{
	return &curMap.tabJump[indice];
}

inline uchar GetTxtID(uchar indice)
{
	return curMap.tabText[indice];
}

inline char GetMaxAni()
{
	return curMap.maxAni;
}

inline uchar GetMapID()
{
	return curMap.mapID;
}

inline ushort PosPxToCase(ushort x, ushort y)
{
	return (x/8)%dimMapX+(y/8)*dimMapX;
}

inline short CaseToPosPxX(short caseID)
{
	return (caseID%dimMapX)*8;
}

inline short CaseToPosPxY(short caseID)
{
	return (caseID/dimMapX)*8;
}


#endif


