/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : DefObj.h						*
 *													*
 *	Object IDs declarations for other files.		*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined DEFOBJ
#define DEFOBJ

//for non interactive objects
#define OBJ_ID_HERO			0
#define OBJ_ID_SCENERY		1

//define for properties
#define P_TERRAN	0
#define P_STOP		1
#define P_WATER		2
#define P_STOP_PUSH	3
#define P_EQUALIZER	4
#define P_KILLER12	5
#define P_KILLER	6
#define P_MTELENOT	7		//8 to 15 are free for others properties... maybe...


#define P_JUMP		16		
#define MAP_JUMP_MAX	16
#define P_TEXT		32		
#define MAP_TEXT_MAX	16	
#define P_ENEMY		48		
#define MAP_ENEMY_MAX	48
#define P_OBJECT	96		
#define MAP_OBJECT_MAX	128

#define P_SCENERY	248	
#define MAP_SCENERY_MAX	8	//always at end

//define for enemies
#define ENEMY_LARVA		P_ENEMY+0
#define ENEMY_CROC		P_ENEMY+1
#define ENEMY_BOUNC		P_ENEMY+2
#define ENEMY_FOLOW		P_ENEMY+3
#define ENEMY_SHADOW1	P_ENEMY+4
#define ENEMY_BLOC		P_ENEMY+5
#define ENEMY_WALL		P_ENEMY+6

//define for items
#define OBJECT_PUSH		P_OBJECT+0		//O
#define OBJECT_RESCAN	P_OBJECT+1		//O
#define OBJECT_KILLALL	P_OBJECT+2		//O
#define OBJECT_SAVE		P_OBJECT+3		//O
#define OBJECT_SHINYS	P_OBJECT+4		//I
#define OBJECT_HEART	P_OBJECT+5		//I
#define OBJECT_BUYER	P_OBJECT+6		//O
#define OBJECT_PLANT	P_OBJECT+7		//O
#define OBJECT_CRACK	P_OBJECT+8		//O
#define OBJECT_E_RELOAD	P_OBJECT+9		//O
#define OBJECT_TARGET_W	P_OBJECT+10		//O
#define OBJECT_TARGET_P	P_OBJECT+11		//O
#define OBJECT_SHIFT_P	P_OBJECT+12		//O
#define OBJECT_SHIFT_M	P_OBJECT+13		//O	
#define OBJECT_HEART_UP	P_OBJECT+14		//I
#define OBJECT_FLINE	P_OBJECT+15		//I
#define OBJECT_KEY		P_OBJECT+16		//I	
#define MAP_KEY_MAX		8
#define OBJECT_LOCK		P_OBJECT+24		//O
#define OBJECT_SWORD	P_OBJECT+32		//W
#define OBJECT_ARROW	P_OBJECT+33		//W
#define OBJECT_BOMB		P_OBJECT+34		//W
#define OBJECT_BOOMG	P_OBJECT+35		//W
#define OBJECT_MTELE	P_OBJECT+36		//I
#define OBJECT_PATTR	P_OBJECT+37		//W


//define for scenery
#define SCENERY_TREE	P_SCENERY+0
#define SCENERY_TREE2	P_SCENERY+1
#define SCENERY_ROCK	P_SCENERY+2
#define SCENERY_COLUMN	P_SCENERY+3
#define SCENERY_STORM	P_SCENERY+4
#define SCENERY_HALO	P_SCENERY+5


#endif







