/****************************************************
 *	Original name : Draw.cpp						*
 *													*
 *	Drawing functions.								*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 ****************************************************/

#include "Draw.h"

#include "DrwSprSW.h"
#include "Data.h"
#include "System2.h"
#include "Keys.h"
#include <conio.h>
#include "Graphic.h"
#include "CLinkedS.h"
#include "CWeapon.h"
#include "CEnemy.h"
#include "System2.h"
#include <dos.h>
#include "LoadFile.h"
#include "Anim.h"

/********************************************************************************
 *																				*
 *						Function Declarations									*
 *																				*
 ********************************************************************************/

void DrawMap(ushort x, ushort y)
{
	//ushort pos=x/8+y/8*dimMapX;
	ushort offsetX=x%8;
	ushort offsetY=y%8;
	uchar indice;
	
	/*for (ushort j=0; j<=DIM_SCR_Y; j++) 
	{	
		y=j*8-offsetY;
		for (ushort i=0; i<=DIM_SCR_X ; i++)
		{
			Draw21SprW_C(i*8-offsetX,y,GetSpr(pos+i),SEG1);
		}
		pos+=dimMapX;
	}*/

	asm {
		mov ax,SEG1;	// segm -> ax
		mov es,ax;		// ax -> es 

		xor dx,dx;
		
		mov bx,x;
		mov ax,y;

		shr bx,3;
		shr ax,3;
		imul dimMapX;

		add ax,bx;
	}

LoopY:
		asm {
			push dx;

			xor cx,cx;

			shl dx,3;
			sub dx,offsetY;
		}

LoopX:
		asm {
			push cx;
			push bx;
			push dx;
			push ax;
		}

		_BL=GetSpr(_AX+_CX);

		asm push ds;

		_SI=memSprMap.b_inner_offset;
		_DS=memSprMap.b_segment;

		asm {
			xor bh,bh;
			shl bx,4;		//bx*8*2->bx	(8 lines, 2 layers)
			add si,bx;		// SI contain address of sprite
		}

		asm {
			shl cx,3;
			sub cx,offsetX;
			mov bx,cx;
		}

	//Start DrawSprite//////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////

	asm {
		//mov bx,x;		// x -> bx
		//mov dx,y;		// y -> dx

		mov di,1023;	// 1023 -> di

		mov cx,bx;		// bx -> cx
		and cx,7;		// cx mod 8 -> cx (shitf)

		mov ch,8;		// 8 -> ch (8=number of lines)
	}

	// Test of vertical clipping  /////////////////////////////////////////
	asm {
		cmp dx,0;
		jl ClippingHaut;//jump if dx<0

		cmp dx,DIM_SCR_PX_Y-1-8+1;
		jg ClippingBas;	//jump if dx>DIM_SCR_PX_Y-1-nbr of lines+1

		jmp SkipClippingVertical;
	}
ClippingHaut:
	asm {
		cmp dx,-8;
		jg OkHaut;
		jmp Finished;
	}
OkHaut:
	asm {
		neg dx;
		add si,dx;		//skip dx first lines of sprite 2
		add si,dx;		//skip dx first lines of sprite 1
		sub ch,dl;		//ch-dl lines to draw

		xor dx,dx;		//0 -> dx
		jmp SkipClippingVertical;
	}
ClippingBas:
	asm {
		cmp dx,DIM_SCR_PX_Y;
		jl OkBas;
		jmp Finished;
	}
OkBas:
	asm {
		mov ax,dx;		//copy dx to ax
		sub ax,DIM_SCR_PX_Y-1-8+1;	//nbr of lines out of screen -> ax
		sub ch,al;		//ch-al lines to draw
	}
	//////////////////////////////////////////////////////////////////////

SkipClippingVertical:
	asm {
		shl dx,4;		// dx*16 -> dx
		sub di,dx;		// di-dx -> di position y

		//Test of horizontal clipping /////////////////////////////////////////
		cmp bx,0;
		jl ClippingGaucheTest;	//jump if bx<0

		mov ax,bx;		// copy bx to ax
		shr ax,3;		// ax/8 -> ax
		sub di,ax;		// di-ax -> di position x

		cmp bx,DIM_SCR_PX_X-1-8+1;
		jg ClippingDroiteTest;	//jump if bx>DIM_SCR_PX_X-1-nbr of lines+1
		//////////////////////////////////////////////////////////////////////

		jmp SkipClippingHorizontal;
	}
		

// Draw /////////////////////////////////////////////////////////////
ClippingGaucheTest:
	asm {
		cmp bx,-8;
		jg ClippingGauche;
		jmp Finished;	//if out of screen
	}
ClippingGauche:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		test al,al;		//byte is null ? skip this line !
		jz PassLineG

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di+NEXT_LAYER],bl;	//draw sprite 2
		//end sprite layer 2
	}
PassLineG:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di],al;	//draw sprite 1

		//end sprite layer1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingGauche;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

ClippingDroiteTest:
	asm {
		cmp bx,DIM_SCR_PX_X;
		jl ClippingDroite;
		jmp Finished;	//if out of screen
	}
ClippingDroite:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si

		test al,al;		//byte is null ? skip this line !
		jz PassLineD;

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di+NEXT_LAYER],bh;	//draw sprite 2
		//end sprite layer 2
	}
PassLineD:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di],ah;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingDroite;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

SkipClippingHorizontal:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si
		
		test al,al;		//byte is null ? skip this line !
		jz PassLine;

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di-1+NEXT_LAYER],bx;	//draw sprite 2
		//end sprite layer 2
	}
PassLine:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di-1],ax;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz SkipClippingHorizontal;	// if ch<>0 goto LoopLigne
	}

//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;

	//End DrawSprite//////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
		
		asm {
			pop ax;
			pop dx;
			pop bx;
			pop cx;

			cmp cx,DIM_SCR_X;
			jz EndLoopX;

			inc cx;
			jmp LoopX;
		}
EndLoopX:
		asm {
			add ax,dimMapX;

			pop dx;

			cmp dx,DIM_SCR_Y;
			jz EndLoopY;

			inc dx;
			jmp LoopY;
		}
EndLoopY:
	
	AnimMap();
	SetMode(MODE_DB);

	globalTimer++;
}

void CenterMapTo(CSprite tSpr)
{
	mapPosX=tSpr.M_POS_Xc-POS_SCR_C_PX_X;
	mapPosY=tSpr.M_POS_Yc-POS_SCR_C_PX_Y;

	if(mapPosX<0) mapPosX=0;
	if(mapPosY<0) mapPosY=0;
	if(mapPosX>posMapMaxPxX) mapPosX=posMapMaxPxX;
	if(mapPosY>posMapMaxPxY) mapPosY=posMapMaxPxY;
}

void DrawScene()
{
	CNode* curNode;

	ClearScreen(SEG1);

	CenterMapTo(hero);
	
	//draw map
	DrawMap(mapPosX,mapPosY);

	//draw items
	for(curNode=items.m_head; curNode!=NULL; curNode=curNode->m_next)
	{
		if(!curNode->m_sprite->IsEnable()) continue;	//sprite is disable
		
		//sprite is enable
		curNode->m_sprite->Draw();
	}

	//draw enemies
	for(curNode=enemies.m_head; curNode!=NULL; curNode=curNode->m_next)
	{
		if(!curNode->m_sprite->IsEnable()) continue;	//sprite is disable
		
		//sprite is enable
		curNode->m_sprite->Draw();
	}

	//draw perso
	hero.Draw();

	//draw scenery
	for(curNode=scenery.m_head; curNode!=NULL; curNode=curNode->m_next)
	{
		//sprite is always enable, or doesn't exist...
		curNode->m_sprite->Draw();
	}

	//draw status bar... it's easy to understand... ;-)
	DrawStatusBar();
}

void DrawStatusBar()
{
	char n;

	//draw the window
	asm {
		mov dx,SEG1
		mov es,dx;

		//layer 1 ////////////////
		//bottom
		mov es:[0],0111111111111110b;

		//top
		mov es:[1008],0111111111111110b;

		//layer 2 ////////////////
		//bottom
		mov es:[0+0x800],0111111111111110b;

		//top
		mov es:[1008+0x800],0111111111111110b;

		//init for loop
		mov cx,62;		//62 lines to draw
		mov di,16;
	}
	//left and right
Loop:
	asm {
		//layer 1 ////////////////
		mov es:[di],1000000000000001b;

		//layer 2 ////////////////
		mov es:[di+0x800],1000000000000001b;

		add di,16;
		loop Loop;	
	}

	//draw hearts bar
	char heartY=DIM_SCR_PX_Y-9;
	for(n=4; n<hero.m_life; n+=4)
	{
		DrawM21SprW(&memSprItem, DIM_SCR_PX_X+4,heartY,OFFSET_BAR_HEART,SEG1);
		heartY-=8;
	}
	
	DrawM21SprW(&memSprItem, DIM_SCR_PX_X+4,heartY,OFFSET_BAR_HEART+hero.m_life%4,SEG1);

	if(hero.m_weapon1!=NULL) DrawM21SprW(&memSprItem, DIM_SCR_PX_X+4,4,hero.m_weapon1->m_sprID[DIR_RIGHT],SEG1);
}

void DrawValueLayer(short value, short segm)
{
	asm {
		mov ax,segm;
		mov es,ax;

		xor dx,dx;
		mov ax,value;
	}
Loop:
	asm {
		mov di,dx;
		add di,16-DIM_SCR_X;

		mov cx,DIM_SCR_X/2;	//divide by 2 because STOSW write words (=2 bytes)
						
		cld;
		rep stosw;

		add dx,16;			//next line
		cmp dx,16*64;		//(16 bytes, 64 lines)
		jnz Loop;
	}
}

BOOL DrawChar(char* x, char* y, char c, ushort segm)
{
	//draw char
	if(c>=32) DrawM21SprW(&memSprFont, (*x), (*y),c-32,segm);

	if (c>='a' && c<='z') 
	{
		(*x)+=DECAY_X_FONT_SMALL;
		return FALSE;
	}
	if (c>='A' && c<='Z') 
	{
		(*x)+=DECAY_X_FONT_CAPITAL;
		return FALSE;
	}
	if (c>='0' && c<='9') 
	{
		(*x)+=DECAY_X_FONT_FIGURE;
		return FALSE;
	}

	switch(c)
	{
	case ' ':
		(*x)+=DECAY_X_FONT_SPACE;
		break;
	case '@':case '\\':
		(*x)+=DECAY_X_FONT_CAPITAL;
		break;
	case '\n':
		(*y)+=DECAY_Y_FONT;
		return TRUE;
	default:
		(*x)+=DECAY_X_FONT_SMALL;
	}


	
	return FALSE;
}

void DrawText(char x, char y, char* text, short segm)
{
	char posX=x;
	char posY=y;
	
	for(ushort car=0; text[car]!='\0'; car++)
	{
		if (DrawChar(&posX, &posY, text[car], segm))	//TRUE if text[car]=='\n'
		{
			posX=x;
		}
	}
}

void DrawWindow(char x1, char y1, uchar x2, uchar y2, short segm)
{
	if(x2-8<0) x2=8;
	if(y2-8<0) y2=8;

	//drawing corners
	DrawM21SprW(&memSprFont, x1,y1,OFFSET_WND_TL,segm);
	DrawM21SprW(&memSprFont, x2-8,y1,OFFSET_WND_TR,segm);
	DrawM21SprW(&memSprFont, x2-8,y2-8,OFFSET_WND_BR,segm);
	DrawM21SprW(&memSprFont, x1,y2-8,	OFFSET_WND_BL,segm);

	int x,y;

	//drawing top and bottom borders
	for(x=x1+8; x<x2-8; x+=8)
	{
		DrawM21SprW(&memSprFont, x,y1,OFFSET_WND_T,segm);
		DrawM21SprW(&memSprFont, x,y2-8,OFFSET_WND_B,segm);
	}

	//drawing left and right borders
	for(x=y1+8; x<y2-8; x+=8)
	{
		DrawM21SprW(&memSprFont, x1,x,OFFSET_WND_L,segm);
		DrawM21SprW(&memSprFont, x2-8,x,OFFSET_WND_R,segm);
	}

	//fill the window
	for(y=y1+8; y<y2-8; y+=8)
	{
		for(x=x1+8; x<x2-8; x+=8)
		{
			DrawM21SprW(&memSprFont, x,y,OFFSET_WND_WHT,segm);
		}
	}
}

void DrawOpeningWindow(char x1, char y1, uchar x2, uchar y2, short segm)
{
	//opening window effect
	short centerX=(x2*128+x1*128)/2;
	short centerY=(y2*128+y1*128)/2;
	short incX=(x2*128-centerX)/SPEED_DISP_TXT;
	short incY=(y2*128-centerY)/SPEED_DISP_TXT;;
	short tmp_x1=centerX;
	short tmp_y1=centerY;
	short tmp_x2=centerX;
	short tmp_y2=centerY;
	
	for(uchar n=0; n<SPEED_DISP_TXT; n++)
	{
		tmp_x1-=incX;
		tmp_y1-=incY;
		tmp_x2+=incX;
		tmp_y2+=incY;
		
		DrawWindow(tmp_x1/128,tmp_y1/128,tmp_x2/128,tmp_y2/128,SEG0);	//SEG0 for fast drawing (without SwapPage)

		Wait(10);
	}

	//draw the window with real dimensions
	DrawWindow(x1,y1,x2,y2,segm);
}

char DisplayTextWindow(char posWnd, char* text, BOOL redrawScene)
{
	char nbrDispLine=0;	//(number of lines)-1 for printing in window
	char dispState=STATE_PRINT;
	char curLine=0;			
	BOOL nextPage=FALSE;	//TRUE if there are an other page
	BOOL endOfTxt=FALSE;	//TRUE if '\0' is find in text
	BOOL endOfDisp=FALSE;	//TRUE if all text have been displayed
	ushort timer;
	ushort car;
	char y1,y2;				//top and bottom of the window


	//count number of lines in text (search '\n')
	for(car=0; text[car]!='\0'; car++)
	{
		if (text[car]=='\n' && nbrDispLine<DISP_MAX_LINE-1) nbrDispLine++;
	}
	
	//calculation of the window height
	switch(posWnd)
	{
	case DISP_WND_BOTTOM:
		y1=DISP_WND_BOTTOM-(nbrDispLine+1)*8-4;
		y2=DISP_WND_BOTTOM;
		break;
	case DISP_WND_TOP:
		y1=DISP_WND_TOP;
		y2=DISP_WND_TOP+(nbrDispLine+1)*8+4;
		break;
	}

	//redraw scene for background
	if(redrawScene)
	{
		DrawScene();
		SwapPage();
	}
	DrawOpeningWindow(DISP_POS_LEFT,y1,DISP_POS_RIGHT,y2,SEG1);
	SwapPage();
	

	//draw the text
	char posX=DISP_POS_LEFT+2;	//position X of current caracter
	char posY=y1+2;				//position Y of current caracter
	char answer=CHOOSE_NOTHING;

	car=0;
	while (answer==CHOOSE_NOTHING && !endOfDisp)
	{
		switch(dispState)
		{
		case STATE_PRINT:
			
			if (DrawChar(&posX, &posY, text[car]))	//TRUE if text[car]=='\n'
			{
				posX=DISP_POS_LEFT+2;
				curLine++;
				if (curLine>nbrDispLine)	//window is full ?
				{
					timer=0;
					posY=y1+2;
					curLine=0;
					dispState=STATE_WAIT;
					SwapPage();
					Wait(2500);		//wait to don't pass next page
				}
			}
			car++;
			
			if (text[car]=='\0')	//end of text ?
			{
				timer=0;
				endOfTxt=TRUE;
				dispState=STATE_WAIT;
			}
			
			break;
		case STATE_WAIT:
			SetMode(MODE_DB);	//for APO

			if (timer%SPEED_ARROW_FLASH==0) 
			{
				SwapPage();
				if (!endOfTxt && nextPage)
				{
					DrawM21SprW(&memSprFont, DISP_POS_RIGHT-8,y2-6,OFFSET_WND_ARR_B,SEG0);
				}
				timer=0;
				nextPage=!nextPage;
			}
			if(Touche(MKS_DOWN) && !endOfTxt)
			{
				dispState=STATE_PRINT;
				DrawWindow(DISP_POS_LEFT,y1,DISP_POS_RIGHT,y2/*,SEG1*/); //clear the window
			}
			if(Touche(MKS_PLUS) && contrastDB<22)
			{
				ContrastP();
				contrastDB++;
				Wait(100);
			}
			if(Touche(MKS_MINUS) && contrastDB>0)
			{
				ContrastM();
				contrastDB--;
				Wait(100);
			}
			timer++;
			break;
		}
		if(Touche(MKS_ESC) || Touche(MKS_EXE)) answer=CHOOSE_QUIT;
		if(Touche(MKS_1)) answer=CHOOSE_1;
		if(Touche(MKS_2)) answer=CHOOSE_2;
		if(Touche(MKS_3)) answer=CHOOSE_3;
		if(Touche(MKS_4)) answer=CHOOSE_4;
		if(Touche(MKS_5)) answer=CHOOSE_5;
		if(Touche(MKS_6)) answer=CHOOSE_6;
		if(Touche(MKS_7)) answer=CHOOSE_7;
		if(Touche(MKS_8)) answer=CHOOSE_8;
		if(Touche(MKS_9)) answer=CHOOSE_9;
		if(Touche(MKS_0)) answer=CHOOSE_0;
	}

	Wait(1000);		//wait to don't quit a previous menu

	return answer;
}

void DrawNextMapFX()
{
	short i,j;

	SwapPage();

	DrawScene();

	asm {
		push ds;
	}
	
	for (i=512; i>=0; i-=16)
	{
		asm {
			mov ax,SEG0;
			mov es,ax;
			
			mov ax,SEG1;
			mov ds,ax;
			
			mov di,i;
			mov si,i;
			
			mov cx,8;
			cld;
			rep movsw;
		}
		asm {
			mov di,1008;
			sub di,i;
			mov si,1008;
			sub si,i;
			
			mov cx,8;
			rep movsw;
		}
		asm {
			mov ax,SEG2;
			mov es,ax;
			
			mov ax,SEG3;
			mov ds,ax;
			
			mov di,i;
			mov si,i;
			
			mov cx,8;
			rep movsw;
		}
		asm {
			mov di,1008;
			sub di,i;
			mov si,1008;
			sub si,i;
			
			mov cx,8;
			rep movsw;
		}
		Wait(16);
	}
	asm {
		pop ds;
	}
	
}

void DrawValueLayer(ushort value, ushort nLine, ushort segm)
{
	asm {
		mov ax,segm;
		mov es,ax;

		xor dx,dx;
		mov ax,value;

		mov bx,nLine;
		shl bx,4;		//16 bytes/line
	}
Loop:
	asm {
		mov di,dx;
		add di,16-DIM_SCR_X;

		mov cx,DIM_SCR_X/2;	//divide by 2 because STOSW write words (=2 bytes)
						
		cld;
		rep stosw;

		add dx,16;			//next line
		cmp dx,bx;
		jnz Loop;
	}
}