/****************************************************
 *	Original name : DrawSprI.cpp					*
 *													*
 *	Functions for drawing 8*8 sprites				*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 ****************************************************/

#include "DrwSprSW.h"
#include "Types2.h"
#include "data.h"
/********************************************************************************
 *																				*
 *						Functions without clipping								*
 *																				*
 ********************************************************************************/

void PaintM21Spr (memory_zone *memz, uchar indice, ushort segm)
{
	asm push ds;

	_SI=memz->b_inner_offset;
	_DS=memz->b_segment;

	asm {
		xor ah,ah;
		mov al, indice;
		mov bx,ax;
		shl ax,1;
		add ax,bx;		//ax*3->ax

		shl ax,3;		//ax*8*3->ax	(8 lines, 2 layers)

		add si,ax;		// SI contain address of sprite

		mov dx,segm;
		mov es,dx;

		xor dx,dx;
	}
Loop1:
	asm {
		mov ax,1022;
		sub ax,dx
		mov di,ax;

		mov ch,8;		//64lines / 8

		//Mask sprite
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		mov bl,al;

		//sprites for layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		push dx;
	}
Loop2:
	asm {
		mov cl,DIM_SCR_X/2;
	}
Loop3:
	asm {

		mov dl,bl;
		mov dh,bl;

		and es:[di],dx;				//draw layer 1
		and es:[di+NEXT_LAYER],dx;	//draw layer 2
		//end of mask sprite

		mov dl,al;
		mov dh,al;

		or es:[di],dx;				//draw sprite 1

		mov dl,ah;
		mov dh,ah;

		or es:[di+NEXT_LAYER],dx;	//draw sprite 2

		sub di,2;

		dec cl;			// cl-1 -> cl for loop
		jnz Loop3;		// if cl<>0 goto Loop3
	}
	asm {
		sub di,16*7+16-DIM_SCR_X; //next line

		dec ch;			// ch-1 -> ch for loop
		jnz Loop2;		// if ch<>0 goto Loop2
	
		pop dx;
		add dx,16;
		cmp dx,16*8;
		jnz Loop1;
	}

//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;
}

void DrawM21SprW	(memory_zone *memz, short x, short y, uchar indice, ushort segm)
{
	asm push ds;

	_SI=memz->b_inner_offset;
	_DS=memz->b_segment;

	asm {
		xor ah,ah;
		mov al, indice;
		mov bx,ax;
		shl ax,1;
		add ax,bx;		//ax*3->ax

		shl ax,3;		//ax*8*3->ax	(8 lines, 2 layers)

		add si,ax;		// SI contain address of sprite

		mov cx,x;		// x -> cx
		mov dx,y;		// y -> dx


		mov di,1022;	// 1022 -> di
		shl dx,4;		// dx*16 -> dx
		sub di,dx;		// di-dx -> di

		mov ax,cx;		// copy cx to ax
		shr ax,3;		// ax/8 -> ax
		sub di,ax;		// di-ax -> di

		and cx,7;		// cx mod 8 -> cx (shifting)

		mov ch,8;		// 8 -> ch (8=number of lines)

		mov dx,segm;
		mov es,dx;
	}

LoopLine:
	asm {
		//Mask sprite
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		mov ah,0xFF;		// 0 -> ah for shifting
		xchg ah,al;		// ah <-> al for shifting
		ror ax,cl;		// shifting of cl bits

		and es:[di],ax;		//draw layer 1
		and es:[di+NEXT_LAYER],ax;	//draw layer 2
		//end of mask sprite

		//sprites for layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		test al,al;		//nothing to draw ? skip this layer !
		jz PassLine2;

		mov bh,al;		//copy byte of sprite 1 to bh

		xor al,al;		//0 -> al
		xor bl,bl;		//0 -> bl
		
		shr bx,cl;		// shift of cl bits sprite 2


		or es:[di+NEXT_LAYER],bx;	//draw sprite 2
		//end sprite layer 2
	}
PassLine2:
	asm {
		//sprite layer 1		
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di],ax;	//draw sprite 1

		//end sprite layer 1
	}
PassLine:
	asm {
		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz LoopLine;	// if ch<>0 goto LoopLigne
	}

//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;
}

/********************************************************************************
 *																				*
 *					 Functions with clipping									*
 *																				*
 ********************************************************************************/

void DrawM21Spr_C	(memory_zone *memz, short x, short y, uchar indice, ushort segm)
{
	asm push ds;

	_SI=memz->b_inner_offset;
	_DS=memz->b_segment;

	asm {
		xor ah,ah;
		mov al, indice;
		mov bx,ax;
		shl ax,1;
		add ax,bx;		//ax*3->ax


		shl ax,3;		//ax*8*3->ax	(8 lines, 2 layers)

		add si,ax;		// SI contain address of sprite

		mov bx,x;		// x -> bx
		mov dx,y;		// y -> dx

		mov ax,segm;	// segm -> ax
		mov es,ax;		// ax -> es 

		mov di,1023;	// 1023 -> di

		mov cx,bx;		// bx -> cx
		and cx,7;		// cx mod 8 -> cx (shitf)

		mov ch,8;		// 8 -> ch (8=number of lines)
	}

	// Test of vertical clipping  /////////////////////////////////////////
	asm {
		cmp dx,0;
		jl ClippingHaut;//jump if dx<0

		cmp dx,DIM_SCR_PX_Y-1-8+1;
		jg ClippingBas;	//jump if dx>DIM_SCR_PX_Y-1-nbr of lines+1

		jmp SkipClippingVertical;
	}
ClippingHaut:
	asm {
		cmp dx,-8;
		jg OkHaut;
		jmp Finished;
	}
OkHaut:
	asm {
		neg dx;
		add si,dx;		//skip dx first lines of sprite M
		add si,dx;		//skip dx first lines of sprite 2
		add si,dx;		//skip dx first lines of sprite 1
		sub ch,dl;		//ch-dl lines to draw

		xor dx,dx;		//0 -> dx
		jmp SkipClippingVertical;
	}
ClippingBas:
	asm {
		cmp dx,DIM_SCR_PX_Y;
		jl OkBas;
		jmp Finished;
	}
OkBas:
	asm {
		mov ax,dx;		//copy dx to ax
		sub ax,DIM_SCR_PX_Y-1-8+1;	//nbr of lines out of screen -> ax
		sub ch,al;		//ch-al lines to draw
	}
	//////////////////////////////////////////////////////////////////////

SkipClippingVertical:
	asm {
		shl dx,4;		// dx*16 -> dx
		sub di,dx;		// di-dx -> di position y

		//Test of horizontal clipping /////////////////////////////////////////
		cmp bx,0;
		jl ClippingGaucheTest;	//jump if bx<0

		mov ax,bx;		// copy bx to ax
		shr ax,3;		// ax/8 -> ax
		sub di,ax;		// di-ax -> di position x

		cmp bx,DIM_SCR_PX_X-1-8+1;
		jg ClippingDroiteTest;	//jump if bx>DIM_SCR_PX_X-1-nbr of lines+1
		//////////////////////////////////////////////////////////////////////

		jmp SkipClippingHorizontal;
	}
		

// Draw /////////////////////////////////////////////////////////////
ClippingGaucheTest:
	asm {
		cmp bx,-8;
		jg ClippingGauche;
		jmp Finished;	//if out of screen
	}
ClippingGauche:
	asm {
		//Mask sprite
		mov ah,0xFF;	// 11111111b -> ah
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		xchg ah,al;		// ah <-> al for shifting
		ror ax,cl;		// shift of cl bits

		and es:[di],al;	//draw right part
		and es:[di+NEXT_LAYER],al;	//draw right part of layer 2
		//end of Mask sprite

		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr ax,cl;		// shift of cl bits sprite 2
		shr bx,cl;		// shift of cl bits sprite 1

		or es:[di+NEXT_LAYER],al;	//draw sprite 2
		//end sprite layer 2

		//sprite layer 1
		or es:[di],bl;	//draw sprite 1

		//end sprite layer1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingGauche;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

ClippingDroiteTest:
	asm {
		cmp bx,DIM_SCR_PX_X;
		jl ClippingDroite;
		jmp Finished;	//if out of screen
	}
ClippingDroite:
	asm {
		//Mask sprite
		mov ah,0xFF;	// 11111111b -> ah
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		xchg ah,al;		// ah <-> al for shifting
		ror ax,cl;		// shift of cl bits


		and es:[di],ah;	//draw left part
		and es:[di+NEXT_LAYER],ah;	//draw left part of layer 2
		//end of Mask sprite

		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr ax,cl;		// shift of cl bits sprite 2
		shr bx,cl;		// shift of cl bits sprite 1

		or es:[di+NEXT_LAYER],ah;	//draw sprite 2
		//end sprite layer 2

		//sprite layer 1
		or es:[di],bh;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingDroite;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

SkipClippingHorizontal:
	asm {
		//Mask sprite
		mov ah,0xFF;	// 11111111b -> ah
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		xchg ah,al;		// ah <-> al for shifting
		ror ax,cl;		// shift of cl bits


		and es:[di-1],ax;	//draw mask
		and es:[di-1+NEXT_LAYER],ax;	//draw mask on layer 2
		//end of Mask sprite

		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr ax,cl;		// shift of cl bits sprite 2
		shr bx,cl;		// shift of cl bits sprite 1

		or es:[di-1+NEXT_LAYER],ax;	//draw sprite 2
		//end sprite layer 2

		//sprite layer 1
		or es:[di-1],bx;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz SkipClippingHorizontal;	// if ch<>0 goto LoopLigne
	}

//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;
}

void Draw21SprW_C	(/*memory_zone *memz,*/ short x, short y, uchar indice, ushort segm)
{
	asm push ds;

	_SI=memSprMap.b_inner_offset;
	_DS=memSprMap.b_segment;

	asm {
		xor ah,ah;
		mov al, indice;
		shl ax,4;		//ax*8*2->ax	(8 lines, 2 layers)
		add si,ax;		// SI contain address of sprite

		mov bx,x;		// x -> bx
		mov dx,y;		// y -> dx


		mov ax,segm;	// segm -> ax
		mov es,ax;		// ax -> es 

		mov di,1023;	// 1023 -> di

		mov cx,bx;		// bx -> cx
		and cx,7;		// cx mod 8 -> cx (shitf)

		mov ch,8;		// 8 -> ch (8=number of lines)
	}

	// Test of vertical clipping  /////////////////////////////////////////
	asm {
		cmp dx,0;
		jl ClippingHaut;//jump if dx<0

		cmp dx,DIM_SCR_PX_Y-1-8+1;
		jg ClippingBas;	//jump if dx>DIM_SCR_PX_Y-1-nbr of lines+1

		jmp SkipClippingVertical;
	}
ClippingHaut:
	asm {
		cmp dx,-8;
		jg OkHaut;
		jmp Finished;
	}
OkHaut:
	asm {
		neg dx;
		add si,dx;		//skip dx first lines of sprite 2
		add si,dx;		//skip dx first lines of sprite 1
		sub ch,dl;		//ch-dl lines to draw

		xor dx,dx;		//0 -> dx
		jmp SkipClippingVertical;
	}
ClippingBas:
	asm {
		cmp dx,DIM_SCR_PX_Y;
		jl OkBas;
		jmp Finished;
	}
OkBas:
	asm {
		mov ax,dx;		//copy dx to ax
		sub ax,DIM_SCR_PX_Y-1-8+1;	//nbr of lines out of screen -> ax
		sub ch,al;		//ch-al lines to draw
	}
	//////////////////////////////////////////////////////////////////////

SkipClippingVertical:
	asm {
		shl dx,4;		// dx*16 -> dx
		sub di,dx;		// di-dx -> di position y

		//Test of horizontal clipping /////////////////////////////////////////
		cmp bx,0;
		jl ClippingGaucheTest;	//jump if bx<0

		mov ax,bx;		// copy bx to ax
		shr ax,3;		// ax/8 -> ax
		sub di,ax;		// di-ax -> di position x

		cmp bx,DIM_SCR_PX_X-1-8+1;
		jg ClippingDroiteTest;	//jump if bx>DIM_SCR_PX_X-1-nbr of lines+1
		//////////////////////////////////////////////////////////////////////

		jmp SkipClippingHorizontal;
	}
		

// Draw /////////////////////////////////////////////////////////////
ClippingGaucheTest:
	asm {
		cmp bx,-8;
		jg ClippingGauche;
		jmp Finished;	//if out of screen
	}
ClippingGauche:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		test al,al;		//byte is null ? skip this line !
		jz PassLineG

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di+NEXT_LAYER],bl;	//draw sprite 2
		//end sprite layer 2
	}
PassLineG:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di],al;	//draw sprite 1

		//end sprite layer1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingGauche;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

ClippingDroiteTest:
	asm {
		cmp bx,DIM_SCR_PX_X;
		jl ClippingDroite;
		jmp Finished;	//if out of screen
	}
ClippingDroite:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si

		test al,al;		//byte is null ? skip this line !
		jz PassLineD;

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di+NEXT_LAYER],bh;	//draw sprite 2
		//end sprite layer 2
	}
PassLineD:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di],ah;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz ClippingDroite;	// if ch<>0 goto LoopLigne
		jmp Finished;
	}

SkipClippingHorizontal:
	asm {
		//sprites layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 1 and 2) and si+2 -> si
		
		test al,al;		//byte is null ? skip this line !
		jz PassLine;

		mov bh,al;

		xor al,al;
		xor bl,bl;
		
		shr bx,cl;		// shift of cl bits sprite 2

		or es:[di-1+NEXT_LAYER],bx;	//draw sprite 2
		//end sprite layer 2
	}
PassLine:
	asm {
		//sprite layer 1
		shr ax,cl;		// shift of cl bits sprite 1

		or es:[di-1],ax;	//draw sprite 1

		//end sprite layer 1

		sub di,16;		// pass to next line

		dec ch;			// ch-1 -> ch for loop
		jnz SkipClippingHorizontal;	// if ch<>0 goto LoopLigne
	}

//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;
}

void DrawM21Bitmap(ushort segm)
{
	asm push ds;

	_SI=memBitmap.b_inner_offset;
	_DS=memBitmap.b_segment;

	asm {
		mov dx,segm;
		mov es,dx;

		xor di,di;
	}

LoopLine:
	asm {
		//Mask sprite
		lodsb;			// [ds,si] -> al (=one byte of spriteM) and si+1 -> si
		not al;

		and es:[di],al;				//draw layer 1
		and es:[di+NEXT_LAYER],al;	//draw layer 2
		//end of mask sprite

		//sprites for layers 2 and 1
		lodsw;			// [ds,si] -> ax (=one byte of sprites 2 and 1) and si+2 -> si

		or es:[di],al;				//draw sprite 2
		or es:[di+NEXT_LAYER],ah;	//draw sprite 1
		//end sprites for layers 2 and 1

		inc di;			// di-1 -> di for loop
		cmp di,1024
		jnz LoopLine;	// if di!=1024 goto LoopLigne
	}
//////////////////////////////////////////////////////////////////////////
Finished:
	asm pop ds;
}