/**
* @package Draw
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : DrawSprI.h						*
 *													*
 *	Header for DrwSprSW.cpp.						*
 *													*
 *	Modifications:									*
 *		- skip empty lines of sprites (Thanks to	*
 *			C@siomax for this idea.)				*
 *		- argument 'indice', and direct read from	*
 *			memory_zone								*
 *													*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/
#if !defined DRWSPRSW
#define DRWSPRSW

#include "Types2.h"
#include "memzones.h"

#pragma inline
/********************************************************************************
 *																				*
 *						Defines													*
 *																				*
 ********************************************************************************/

#define NEXT_LAYER	2048	// 1 page=layer have a size of 1024 bytes
							// 1024*2 for greyscale

/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *		Help for names of functions ?											*
 *																				*
 *	M		- means sprites contain mask										*
 *	21		- means sprites are 2 layers for greyscale							*
 *	_C		- enable clipping													*
 *	W_		- With zero test (if byte is null, skip this byte, usefull if		*
 *				sprite has less than 8 lines with non null bytes)				*
 *																				*
 ********************************************************************************/

extern void DrawM21SprW		(memory_zone *memz, short x, short y, uchar indice, ushort segm);
extern void DrawM21Spr_C	(memory_zone *memz, short x, short y, uchar indice, ushort segm);
extern void Draw21SprW_C	(/*memory_zone *memz,*/ short x, short y, uchar indice, ushort segm);
extern void DrawM21Bitmap	(ushort segm);
extern void PaintM21Spr		(memory_zone *memz, uchar indice, ushort segm);

#endif
