// ******************************************************************
// * Je remercie avant tout MasterMage qui a bien voulu				*
// * fournir ses routines, que j'ai ensuite dbuggues et intgres	*
// * dans cette librairie. J'espre qu'elle vous conviendra.		*
// *																*
// * CopyRight (c) 2002 Wahb Ettoumi								*
// ******************************************************************

// ******************************************************************
// *		Modifications apportes le 10/05/2003 par LeadFiner		*
// *		nom d'origine : MXDRAW.H								*
// ******************************************************************

#include "Graphic.h"
#include <mem.h>
#include <dos.h>


/**************** Fonctions ****************************************/

//Passe en mode graphique noir,gris,blanc
void SetMode(uchar mode)
{
	asm {
		mov al,mode
		out 2 ,al
	}
}

/*short GetCurSeg(void)
{
  return peek(0x4E,0);
}*/

//Modifie l'adresse du buffer video (Libithium)
/*void SetCurSeg(short segm)
{
	asm {
		mov ax,segm
		xor dx,dx
		shl ax,1
		rcl dx,1
		shl ax,1
		rcl dx,1
		shl ax,1
		rcl dx,1
		shl ax,1
		rcl dx,1
		out 0x05,ax
		mov al,dl
		out 0x07,al
	}
}*/

/************Utilisation de l'cran************/

//Efface l'cran (=pages (0 et 2) ou (1 et 3) en niveaux de gris)
void ClearScreen(short firstSeg)
{
	ClearPage(firstSeg);
	ClearPage(firstSeg+0x80);
}

void ClearPage(short segm)
{
	asm {
		mov ax,segm
		mov es,ax

		xor di,di
		xor ax,ax

		mov cx,512		//1 page= 1024 octets
						//on divise par 2 car on crit des mots (=2 octets) avec STOSW
		cld 
		rep stosw
	}
}

//Efface l'cran avec la valeur val (=pages (0 et 2) ou (1 et 3) en niveaux de gris)
/*void ClearScreenWith(short firstSeg, short val)
{
	ClearPageWith(firstSeg, val);
	ClearPageWith(firstSeg+0x80, val);
}*/

void ClearPageWith(short segm, short val)
{
	asm {
		mov ax,segm
		mov es,ax

		xor di,di
		mov ax,val

		mov cx,512		//1 page= 1024 octets
						//on divise par 2 car on crit des mots (=2 octets) avec STOSW
		cld 
		rep stosw
	}
}

//augmente ou diminue le contraste 1 fois
/*void Contraste(uchar sens)
{
	asm {
		mov ah,22h
		mov bl,sens
		int 7Ch
	}
}*/

//augmente ou diminue le contraste nbr fois
void Contrast(uchar sens, uchar nbr)
{
	asm {
		xor cx,cx
		mov cl,nbr
		jcxz skip	//si cx=0 rien  faire
	}
boucle:
	asm {
		mov ah,22h
		mov bl,sens
		push cx		//int 7Ch modifie cx...
		int 7Ch
		pop	cx
		loop boucle
	}
skip:
}

//GetContrast by Swiffer
uchar GetContrast()
{
	asm {
		mov ax,0x40;
		mov es,ax;
		mov al,es:0xE5;
		sub al,0x12;
		shr al,0x1;
	}
	return _AL;
}

//met le contraste  la valeur val (diminue au mini puis augmente val fois)
void ContrastTo(char val)
{
	Contrast(CONT_MOINS,22);	//22 niveaux de contraste
	if(val>0) Contrast(CONT_PLUS,val);
}

//augmente le contraste
void ContrastP()
{
	asm {
		mov ah,22h
		mov bl,0
		int 7Ch
	}
}

//diminue le contraste
void ContrastM()
{
	asm {
		mov ah,22h
		mov bl,1
		int 7Ch
	}
}

//Copie l'cran (1024 octets) de start  dest
//Exemple: CopyPage(0x1A20,0x1A60);
/*void CopyPage(short segsrc, short segdest)
{
	asm {
		push ds

		mov ax,segdest
		mov es,ax

		mov ax,segsrc
		mov ds,ax

		xor di,di
		xor si,si
		
		mov cx,0x200
		cld
		rep movsw

		pop ds
	}
}*/

//Copie SEG1 vers SEG0 et SEG3 vers SEG2
//equivaut  : 
//CopyPage(SEG1,SEG0);
//CopyPage(SEG3,SEG2);
void SwapPage()
{
	asm {
		push ds

		mov ax,SEG0
		mov es,ax

		mov ax,SEG1
		mov ds,ax

		xor di,di
		xor si,si
		
		mov cx,0x200
		cld
		rep movsw

		mov ax,SEG2
		mov es,ax

		mov ax,SEG3
		mov ds,ax

		xor di,di
		xor si,si
		
		mov cx,0x200
		cld
		rep movsw

		pop ds
	}
}

