/**
* @package Keys
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : Keys.h							*
 *													*
 *	Functions for keyboard.							*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined KEYS
#define KEYS

#include "Types2.h"


/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

#ifdef __cplusplus
    #define __CPPARGS ...
#else
    #define __CPPARGS
#endif

// C: column
// L: line
// Key definitions :0xCL 
#define MKS_F1		0x6A
#define MKS_F2		0x5A
#define MKS_F3		0x4A
#define MKS_F4		0x3A
#define MKS_F5		0x2A
#define MKS_F6		0x1A
#define MKS_SHIFT	0x68
#define MKS_CTRL	0x58
#define MKS_OPTN	0x48
#define MKS_MENU	0x38
#define MKS_UP		0x59
#define MKS_DOWN	0x49
#define MKS_LEFT	0x69
#define MKS_RIGHT	0x39
#define MKS_ALPHA	0x67
#define MKS_VARS	0x57
#define MKS_POW		0x47
#define MKS_ESC		0x37
#define MKS_XOT		0x66
#define MKS_LOG		0x56
#define MKS_LN		0x46
#define MKS_SIN		0x36
#define MKS_COS		0x26
#define MKS_TAN		0x16
#define MKS_ABC		0x65
#define MKS_X2		0x55
#define MKS_OPNBRK	0x45
#define MKS_CLSBRK	0x35
#define MKS_COMMA	0x25
#define MKS_ARROW	0x15
#define MKS_7		0x64
#define MKS_8		0x54
#define MKS_9		0x44
#define MKS_DEL		0x34
#define MKS_AC		0x24
#define MKS_4		0x63
#define MKS_5		0x53
#define MKS_6		0x43
#define MKS_PROD	0x33
#define MKS_DIV		0x23
#define MKS_1		0x62
#define MKS_2		0x52
#define MKS_3		0x42
#define MKS_PLUS	0x32
#define MKS_MINUS	0x22
#define MKS_0		0x61
#define MKS_DOT		0x51
#define MKS_EXP		0x41
#define MKS_ANS		0x31
#define MKS_EXE		0x21

extern void interrupt EmptyInt(__CPPARGS);		//empty interruption
extern void interrupt (*SaveInt)(__CPPARGS);	//save interruption 

/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/

extern BOOL Touche(uchar code);		//return TRUE if key is pressed
extern void SetDisableKeyBuf();
extern void SetEnableKeyBuf();

#endif