/**
* @package LoadFile
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : LoadFile.h						*
 *													*
 *	Functions for finding, loading files.			*
 *													*
 *	Modifications July 2003 :						*
 *		- copy file into memory zone				*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined LOADFILE
#define LOADFILE

#include "Data.h"
#include "io.h"

/********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

extern int (*handler)(int,int,int,int);

/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/
extern int error_handler(int a,int b,int c,int d);
extern BOOL FindDrive ();		// search the specified file, set the current drive and return handle to file
extern void LoadMap(uchar mapID);		// load map with ID mapID from the file WORLD.WLD into curMap
extern void LoadBitmap(uchar* file);		// load the file "file" into memBitmap zone
extern char* LoadText(ushort txtID);	// load text with ID txtID from the file TEXT.TXT into curText and return curText
extern BOOL SaveGame(uchar slot);		// save game into basic file DEFAULT_MEM_SAVE
extern BOOL LoadGame(uchar slot);		// load game from basic file DEFAULT_MEM_SAVE
extern BOOL SaveConfig();				// save config into basic file DEFAULT_MEM_SAVE
extern BOOL LoadConfig();				// load config from basic file DEFAULT_MEM_SAVE
extern void DecompressFileToMemzone(uchar *file, memory_zone *memz); 
extern void DecompressBufferToBuffer(uchar* srcBuffer, uchar* dstBuffer, ushort sizeCompress, uchar compressTag);
extern void DecompressBufferToMemzone(uchar* srcBuffer, memory_zone *memz, ushort sizeCompress, uchar compressTag);
#endif