/**
* @package Map
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : Map.h							*
 *													*
 *	Header for Map.cpp								*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/
#pragma once

#if !defined MAP
#define MAP

#include "Types2.h"
#include "CPerso.h"
#include "CEnemy.h"
#include "CItem.h"
#include "CWeapon.h"
#include "CLinkedS.h"


/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/

extern uchar TestProp(uchar curProp, uchar prevReturnProp);	//return Prop with priority for P_STOP (see PropIs())
extern void ScanMapEnemy();					//scan all squares of map and create enemies
extern void ScanMapItem();					//scan all squares of map and create items
extern void ScanMapScenery();				//scan all squares of map and create scenery
extern void UpdateEnemy();					//enable or disable sprite depening on map
extern void UpdateItem();					//enable or disable sprite depening on map
extern void DeleteSpritesInMap(CLinkedSprites* sprList, uchar mapID);	//all is said in name !!!
extern void DeleteSpecialItemInMap(uchar mapID);
extern CEnemy* AddEnemy(uchar enemyID, short posX, short posY);
extern CItem* AddItem(uchar itemID, short posX, short posY);
extern CWeapon* AddHeroWeapon(uchar weaponID, uchar extra=1);
extern CItem* AddHeroItem(uchar itemID, uchar extra=1);
extern void GenerateRndItem(short posX, short posY);
extern void KillAllInMap(uchar mapID, char enemyID=-1);	//default -1 for all
extern uchar CountEnemyInMap(uchar mapID);
extern void GlobalUpdate();
extern BOOL IsItemForKliz(uchar objID);
#endif