/**
* @package SW_Main
*/
/****************************************************
 *	Part of Shadow World project					*
 *													*
 *	Original name : SW.h							*
 *													*
 *	The main program for Shadow World.				*
 *													*
 *													*
 *	May 2003, LeadFiner								*
 *	LeadFiner@wanadoo.fr							*
 ****************************************************/

#if !defined SW
#define SW

#include "Types2.h"

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/********************************************************************************
 *																				*
 *						Data Declarations and Defines							*
 *																				*
 ********************************************************************************/

//for intro
#define STATE_INTRO_FADE	0
#define STATE_INTRO_SHADOW	1
#define STATE_MENU_NEW		2
#define STATE_MENU_NEW_F	3
#define STATE_MENU_LOAD		4
#define STATE_MENU_LOAD_F	5
#define STATE_MENU_QUIT		8
#define STATE_MENU_QUIT_F	9
#define STATE_MENU_WAIT		16

#define CHOICE_NEW			1
#define CHOICE_LOAD			2
#define CHOICE_QUIT			4
#define CHOICE_PLAY			8

#define SPR_MENU_NEW		128
#define SPR_MENU_LOAD		144
#define SPR_MENU_QUIT		160
#define SPR_ROTATE			176

//for inventory
#define INV_NONE			0
#define INV_WEAPONS			1
#define INV_ITEMS			2
#define INV_SPR_SEL			128
#define INV_SPR_WEAPONS		130
#define INV_SPR_ITEMS		132


/********************************************************************************
 *																				*
 *						Function Prototypes										*
 *																				*
 ********************************************************************************/

extern void InitProg();
extern void InitGame();
extern void QuitGame();

extern void GameOver();
extern void Play();
extern void Intro();
extern uchar StartMenu();
extern void Inventory();

#endif