/****************************************************
 *	Original name : CI_Crack.cpp					*
 *													*
 *	Class for using bomb rock crack.				*
 *													*
 *													*
 *	July 2003, LeadFiner							*
 ****************************************************/
#include "CI_Crack.h"
#include "Anim.h"
#include "DrwSprSW.h"
#include "Data.h"
#include "Map.h"
#include "Draw.h"
#include "CHero.h"
#include "LoadFile.h"
#include "CLinkedS.h"
#include "System2.h"

 /********************************************************************************
 *																				*
 *						Data Declarations										*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class constructors										*
 *																				*
 ********************************************************************************/

CI_Crack::CI_Crack(short initX, short initY)
	:CItem(OBJECT_CRACK, initX, initY
	, CRACK_MARGE_BOTTOM
	,CRACK_MARGE_LEFT
	,CRACK_MARGE_TOP
	,CRACK_MARGE_RIGHT
	,CRACK_SPR_ID
	,CRACK_ANI_LEN)
{
	m_isCrack=FALSE;
	m_timer=0;
}

/********************************************************************************
 *																				*
 *						Class methodes inline									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class virtual methodes									*
 *																				*
 ********************************************************************************/

/********************************************************************************
 *																				*
 *						Class methodes											*
 *																				*
 ********************************************************************************/	

BOOL CI_Crack::Action()
{
	return m_isCrack;
}

void CI_Crack::Draw()
{
	if(m_timer==0) 
	{
		CItem::Draw();
		SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_STOP);
		
		if(hero.m_weapon1==NULL) return;
		
		if(hero.m_weapon1->m_objectID!=OBJECT_BOMB) return;
		
		if(hero.m_weapon1->IsEnable() && TestCollision((CSprite*) hero.m_weapon1))
		{
			SetProp(PosPxToCase(M_POS_Xc,M_POS_Yc),P_TERRAN);
			
			//enable collision with hero
			SetMarginRect(CRACK_MARGE_BOTTOM-64,CRACK_MARGE_LEFT-64,CRACK_MARGE_TOP-64,CRACK_MARGE_RIGHT-64);
			m_timer++;
		}
	}
	else
	{
		DrawM21Spr_C(&memSprItem, m_posX-mapPosX,m_posY-mapPosY,DEFAULT_SPR_EXPLODE+m_timer/2,SEG1);
		
		if(m_timer==15)	m_isCrack=TRUE;

		m_timer++;
	}
}
